// CFEMPlotter.cpp: implementation of the CFEMPlotter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CFEMPlotter.h"
#include "..\WinGUI\IWinGUI.h"										// IWinGUI
#include "..\..\PlugInSource\MessageHandler\IMessageHandler.h"		// IMessageHandler
#include "commdlg.h"												// OPENFILENAME, GetOpenFileName
#include "..\GraphLib\IGraphLib.h"									// I2DMemoryDC
#include "DVA\CuthillMcKee.h"										// CCuthillMcKee Algorithmus

#include "DVA\FemElement.h"											// eET_PARALLELOGRAMM

#include <mmsystem.h>
#include <stdio.h>
#include <assert.h>
#include <shellapi.h>
#include <math.h>													// floor

#include "..\..\shared\GUIAppData.h"								// CGUIAppData

// Extract the error code from an HRESULT
#define CODEFROMHRESULT(hRes) ((hRes) & 0x0000FFFFUL)


#define ERR if(g_App->GetErrorHandler())(g_App->GetErrorHandler())		// fr Fehlerausgabe
#define MESS if(g_App->GetMessageHandler())(g_App->GetMessageHandler())		// fr Logfileausgabe


extern IEditorApplication *g_App;


// Tippersparniss fr WinGUI
#define BEGIN	{ CHandle<ISceneGraphObject> nsich=n; n=
#define END		n=nsich; }

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFEMPlotter::CFEMPlotter() : CDocObject(),m_scale(100.0f),m_femproc(&m_perftime),m_subx(0),m_suby(0)
{
	// Var Init
	InitVar();

	assert(g_App);

	IWinGUI *gui=g_App->GetWinGUI();





	CRGUI_AlignMode m=alignl_stretch;
	CHandle<ISceneGraphObject> n;

	n=gui->CreateWindow_Dialog(eNone,static_cast<IGUIDialogCallback *>(this),"FEM Plotter",false,m,m);
	assert(n);

	m_MainGUIDialog=GETINTERFACE(n,IWinGUIDialog);

	BEGIN gui->InsertButton_Group(n,"",false,m,m,borderm_none);

		BEGIN gui->CreateWindow_MenuBar(eNone,n,"");

			BEGIN gui->CreateWindow_MenuBar(eNone,n,			"Datei");
				gui->CreateWindow_MenuBar(eOpenFEMIN,n,				"FEMIN ffnen ...");
				gui->CreateWindow_MenuBar(eOpenFEMOUT,n,			"FEMOUT ffnen ...");
				gui->CreateWindow_MenuBar(eSubdiv,n,				"---");
				gui->CreateWindow_MenuBar(eCalcAndSave_Array,n,		"FEMOUT berechnen(Array) und speichern");
				gui->CreateWindow_MenuBar(eCalcAndSave_Hull,n,		"FEMOUT berechnen(Hull) und speichern");
				gui->CreateWindow_MenuBar(eCalcAndSave_List,n,		"FEMOUT berechnen(List) und speichern");
				gui->CreateWindow_MenuBar(eSubdiv,n,				"---");
				gui->CreateWindow_MenuBar(eSubdiv,n,				"Netzverfeinerung");
			END

		END

	END


	CHandle<ISceneGraphObject> _c1,_c2,_c3,_c4,_c5,_c6,_c7,_c8,_c9,_c10,_c11;

	BEGIN gui->InsertButton_Group(n,"FEM Gebiet",false,m,m,borderm_edgedframe);
		gui->InsertButton_Static(eNodeCountOutput,n,"keine Daten geladen");
		gui->InsertButton_Static(eMemoryOutput,n,"");
	END

	BEGIN gui->InsertButton_Group(n,"Anzeige",false,m,m,borderm_edgedframe);
		BEGIN gui->InsertButton_Group(n,"",false,m,m,borderm_none);

			BEGIN gui->InsertButton_Group(n,"Potentiallinien",false,m,m,borderm_edgedframe);

				BEGIN gui->InsertButton_Group(n,"",true,m,m,borderm_none);
					_c1=gui->InsertButton_Check(eDisplayU,n,"U Werte");
					_c5=gui->InsertButton_Edit(eStepperU,n,"");
				END
				BEGIN gui->InsertButton_Group(n,"",true,m,m,borderm_none);
					_c2=gui->InsertButton_Check(eDisplayV,n,"V Werte");
					_c6=gui->InsertButton_Edit(eStepperV,n,"");
				END
				
				_c10=gui->InsertButton_Check(eHighQualityInterpolation,n,"HighQuality");

			END

			_c3=gui->InsertButton_Check(eDisplayElements,n,"Elementnummern");

			BEGIN gui->InsertButton_Group(n,"",true,m,m,borderm_none);
				BEGIN gui->InsertButton_Group(n,"",false,m,m,borderm_none);
					_c4=gui->InsertButton_Check(eDisplayNodes,n,"Knotennummern");
					_c8=gui->InsertButton_Check(eDisplayMatrix,n,"Gesamtsteifigkeitsmatrix ");
				END
				BEGIN gui->InsertButton_Group(n,"",false,m,m,borderm_none);
					_c9=gui->InsertButton_Check(eDisplayNodesOptimized,n,"Cuthill-McKee");
					_c11=gui->InsertButton_Check(eDisplayMatrixOptimized,n,"Cuthill-McKee");
				END
			END

			_c7=gui->InsertButton_Check(eDisplayEdges,n,"Elementrnder");

		END

	END

	CHandle<I2DAutoLayout> aut;

	n->QueryInterface(IID_I2DAutoLayout,(void **)&aut);
	assert(aut);

	aut->RecalcLayoutRecursive();
	{
		ULONG id=1;

		aut->CreateLayoutRecursive(id);
	}



	// Alle Anzeigen auf an setzen
	{
		CHandle<IWinGUIButton> f;

		
		f=GETINTERFACE(_c1 ,IWinGUIButton);f->SetValue(1);m_displayValues[0]=true;
		f=GETINTERFACE(_c2 ,IWinGUIButton);f->SetValue(1);m_displayValues[1]=true;
		f=GETINTERFACE(_c3 ,IWinGUIButton);f->SetValue(1);m_displayValues[2]=true;
		f=GETINTERFACE(_c4 ,IWinGUIButton);f->SetValue(1);m_displayValues[3]=true;
		f=GETINTERFACE(_c5 ,IWinGUIButton);f->SetText("1.0");m_StepperU=1.0f;
		f=GETINTERFACE(_c6 ,IWinGUIButton);f->SetText("1.0");m_StepperV=1.0f;
		f=GETINTERFACE(_c7 ,IWinGUIButton);f->SetValue(1);m_displayValues[4]=true;
		f=GETINTERFACE(_c8 ,IWinGUIButton);f->SetValue(0);m_displayValues[5]=false;
		f=GETINTERFACE(_c9 ,IWinGUIButton);f->SetValue(0);m_displayValues[6]=false;
		f=GETINTERFACE(_c10,IWinGUIButton);f->SetValue(0);m_displayValues[7]=false;	// HighQuality
		f=GETINTERFACE(_c11,IWinGUIButton);f->SetValue(0);m_displayValues[8]=false;	// MatrixOpti
	}


}

CFEMPlotter::~CFEMPlotter()
{
	delete [] m_CuthillMcGeeResult;
	// Free Resources, Cleanup

	long f=((CComponentBase *)((IUnknown_ND*)this))->GetRefCount();		// Debug
}


void CFEMPlotter::InitVar()
{
	m_CuthillMcGeeResult=0;
	m_perftime.Init();
}


void CFEMPlotter::CalcCuthillMcGee( void )
{
	DWORD len=m_femproc.GetFemData().GetNodeCount();

	CCuthillMcKee mycut(len);

	// erspart den Code 2x zu schreiben
	CFemElement *el[2]=
	{ 
		&(m_femproc.GetFemData().GetTriangleElements()),
		&(m_femproc.GetFemData().GetRectangleElements())
	};

	for(int pass=0;pass<2;pass++)
	{
		int NodesPE=el[pass]->GetType();										// Knoten pro Element
		DWORD connect[8];

		assert(NodesPE<=8);

		for(int i=0;i<el[pass]->GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<NodesPE; j++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				DWORD x=el[pass]->GetNodeNr(i, j)-1;

				connect[j]=x;
			}
			mycut.PreAddElement(NodesPE,connect);
		}
	}

	for(pass=0;pass<2;pass++)
	{	
		int NodesPE=el[pass]->GetType();										// Knoten pro Element
		DWORD connect[8];

		assert(NodesPE<=8);

		for(int i=0;i<el[pass]->GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<NodesPE; j++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				DWORD x=el[pass]->GetNodeNr(i, j)-1;

				connect[j]=x;
			}
			mycut.AddElement(NodesPE,connect);
		}
	}


	m_CuthillMcGeeResult=new DWORD[len];

	DWORD *res=mycut.GetResult();

//	mycut.DoOneCalculation(0x6732);
	mycut.DoNCalculations(30,0x4554);
		
	for(DWORD i=0;i<len;i++)
		m_CuthillMcGeeResult[*res++]=i;
}


bool CFEMPlotter::IsObjectAt(CPoint2I xy)
{
	return(m_rect.PtInRect(xy));
}

void CFEMPlotter::ReleaseObject( void )
{
	m_MainGUIDialog->ReleaseWindow();
//	m_MainGUIDialog->ReleaseObject();
	m_MainGUIDialog=0;						// freigeben
	CDocObject::ReleaseObject();
}


void PlotInnerTriangle( I2DMemoryDC *pMC, CPoint2F p[3], float value[3], float step, CColor col )
{
	if(step<=0.0f)return;

	// Min
	float min=value[0];
	int mini=0;

	if(value[1]<min){ min=value[1];mini=1; }
	if(value[2]<min){ min=value[2];mini=2; }

	// Max
	float max=value[0];
	int maxi=0;

	if(value[1]>max){ max=value[1];maxi=1; }
	if(value[2]>max){ max=value[2];maxi=2; }

//	if(min==max)return;

	int fromi=mini;	if((mini+1)%3 != maxi)fromi=maxi;
	int toi=(fromi+1)%3;
	int gegenueber=(fromi+2)%3;

	// quipotentiallinien zeichnen
	float start=floor(min/step+1.0)*step;

	if((max-start)>1000.0f*step)return;

	for(float f=start;f<=max;f+=step)
	{
		float ax,ay,bx,by;

		float alpha=(f-value[toi])/(value[fromi]-value[toi]);

		ax=(float)p[fromi].x*alpha+(float)p[toi].x*(1.0f-alpha);
		ay=(float)p[fromi].y*alpha+(float)p[toi].y*(1.0f-alpha);

		if(value[gegenueber]<f)
		{
			float beta=(f-value[gegenueber])/(value[maxi]-value[gegenueber]);

			bx=(float)p[maxi].x*beta+(float)p[gegenueber].x*(1.0f-beta);
			by=(float)p[maxi].y*beta+(float)p[gegenueber].y*(1.0f-beta);
		}
		else
		{
			float beta=(f-value[gegenueber])/(value[mini]-value[gegenueber]);

			bx=(float)p[mini].x*beta+(float)p[gegenueber].x*(1.0f-beta);
			by=(float)p[mini].y*beta+(float)p[gegenueber].y*(1.0f-beta);
		}

		pMC->LineAA(ax,ay,bx,by,255,col);	
	}
}




// Interface I2DDrawObject
// pos ist in Weltkoordinaten
void CFEMPlotter::Draw( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify ) 
{
	assert(pMC);

	CRect2I rect2;

	float mag=m_scale/(1<<inMagnify);
	
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	rect2.left=		((m_rect.left+1-pos.x)>>inMagnify);
	rect2.right=	((m_rect.right-pos.x)>>inMagnify);
	rect2.top=		((m_rect.top+1-pos.y)>>inMagnify);
	rect2.bottom=	((m_rect.bottom-pos.y)>>inMagnify);


//	pMC->Rect(rect2,3,0xa0a0d0);

	rect2.left-=3;
	rect2.right+=3;
	rect2.top-=3;
	rect2.bottom+=3;
	pMC->FillRect(rect2,0xffffff);						// Hintergrund

	assert(m_femproc.GetFemData().GetCalcCount()<=2);

	// Potentiallinien zeichnen
	DrawElementPot(pMC,pos,inMagnify);
	
	// Rand zeichnen
	if(m_displayValues[4])
		DrawEdges(pMC,pos,inMagnify);

	// Elementrnder zeichnen
	if(m_displayValues[2])
		DrawElementNumbers(pMC,pos,inMagnify);

	// Knotennummern zeichnen
	if(m_displayValues[3] && !m_displayValues[6])
		DrawNodeNumbers(pMC,pos,inMagnify);

	// Knotennummern zeichnen
	if(m_displayValues[3] && m_displayValues[6])
		DrawNodeNumbersOptimized(pMC,pos,inMagnify);

	// Matrix darstellen
	if(m_displayValues[5] && !m_displayValues[8])
		DrawMatrix(pMC,pos,inMagnify);
	
	// Matrix darstellen
	if(m_displayValues[5] && m_displayValues[8] && m_CuthillMcGeeResult)
		DrawOptimizedMatrix(pMC,pos,inMagnify);
}


void CFEMPlotter::DrawElementPot( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	for(int iCalcNr=0;iCalcNr<m_femproc.GetFemData().GetCalcCount();iCalcNr++)
	{
		float stepper;

		if(iCalcNr==0)stepper=m_StepperU;
			else stepper=m_StepperV;

		if(!m_displayValues[iCalcNr])continue;							// nur wenn Checkbox an ist

		CColor col;
			
		switch(iCalcNr)													// Innen-Farbe
		{
			case 0:	col=CColor(0x0000ff);break;
			case 1:	col=CColor(0xff0000);break;

			default: break;
		}

		int i;

		CFemElement &el=m_femproc.GetFemData().GetTriangleElements();

		// -- Zeichnen der Dreiecks Elemente
		// 
		{
			for(i=0;i<el.GetCount();i++)									// Alle Elemente
			{	
				float x[3],y[3];
				CPoint2F p[3];
				float value[3];

				for (int j=0; j<3; j++)
				{
					//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
					//
					int iNodeNr=el.GetNodeNr(i, j)-1;

					assert(iNodeNr >= 0);

					if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
						throw "GetNodeCoord-Error";

					value[j]=m_femproc.GetFemData().GetUVValue(iCalcNr,iNodeNr);
					p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						          (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
				}

				if(el.GetType()==6)									// Potentiallinien High Quality
				{
					const float Steps=7.0f;

					float InvSteps=1.0f/Steps;
					for(float Eta=0.0f;Eta<=1.01f;Eta+=InvSteps)
					for(float Xi=0.0f;Xi<=1.01f-Eta-InvSteps;Xi+=InvSteps)
					{
						float x[4],y[4];
						double uv[4];
			
						if(m_femproc.GetFemData().UVInterpolationTriangle(iCalcNr,i,Xi,Eta,x[0],y[0],uv[0]))
						if(m_femproc.GetFemData().UVInterpolationTriangle(iCalcNr,i,Xi+InvSteps,Eta,x[1],y[1],uv[1]))
						if(m_femproc.GetFemData().UVInterpolationTriangle(iCalcNr,i,Xi,Eta+InvSteps,x[2],y[2],uv[2]))
						if(m_femproc.GetFemData().UVInterpolationTriangle(iCalcNr,i,Xi+InvSteps,Eta+InvSteps,x[3],y[3],uv[3]))
						{
							CPoint2F p2[3];
							float v2[3];

							p2[0]=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[1]=CPoint2F((x[1]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[1]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[2]=CPoint2F((x[2]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[2]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);

							v2[0]=uv[0];v2[1]=uv[1];v2[2]=uv[2];

							PlotInnerTriangle(pMC,p2,v2,stepper,col);

							if(Xi+Eta+InvSteps<1.0)
							{
								p2[0]=CPoint2F((x[3]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
									(ho/m_scale-y[3]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							
								v2[0]=uv[3];

								PlotInnerTriangle(pMC,p2,v2,stepper,col);
							}
						}
					}
				}
				else PlotInnerTriangle(pMC,p,value,stepper,col);
			}
		}

		// -- Zeichnen der Vierecks Elemente
		// 
		{
			CFemElement &el=m_femproc.GetFemData().GetRectangleElements();

			for(i=0;i<el.GetCount();i++)									// Alle Elemente
			{	
				float x[4],y[4];
				CPoint2F p[4];
				float value[4];

				for (int j=0; j<4; j++)
				{
					//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
					//
					int iNodeNr=el.GetNodeNr(i, j)-1;

					assert(iNodeNr >= 0);

					if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
						throw "GetNodeCoord-Error";

					value[j]=m_femproc.GetFemData().GetUVValue(iCalcNr,iNodeNr);
					p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						          (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
				}


				if(m_displayValues[7] || el.GetType()==8)									// Potentiallinien High Quality
				{
					const float Steps=7.0f;

					float InvSteps=1.0f/Steps;
					for(float Xi=0.0f;Xi<1.0f;Xi+=InvSteps)
					for(float Eta=0.0f;Eta<1.0f;Eta+=InvSteps)
					{
						float x[4],y[4];
						double uv[4];

						if(m_femproc.GetFemData().UVInterpolationRectangle(iCalcNr,i,Xi,Eta,x[0],y[0],uv[0]))
						if(m_femproc.GetFemData().UVInterpolationRectangle(iCalcNr,i,Xi+InvSteps,Eta,x[1],y[1],uv[1]))
						if(m_femproc.GetFemData().UVInterpolationRectangle(iCalcNr,i,Xi+InvSteps,Eta+InvSteps,x[2],y[2],uv[2]))
						if(m_femproc.GetFemData().UVInterpolationRectangle(iCalcNr,i,Xi,Eta+InvSteps,x[3],y[3],uv[3]))
						{
							CPoint2F p2[3];
							float v2[3];

							p2[0]=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[1]=CPoint2F((x[1]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[1]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[2]=CPoint2F((x[2]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[2]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);

							v2[0]=uv[0];v2[1]=uv[1];v2[2]=uv[2];

							PlotInnerTriangle(pMC,p2,v2,stepper,col);

							p2[0]=CPoint2F((x[2]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[2]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[1]=CPoint2F((x[3]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[3]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
							p2[2]=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
								(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);

							v2[0]=uv[2];v2[1]=uv[3];v2[2]=uv[0];

							PlotInnerTriangle(pMC,p2,v2,stepper,col);
						}
					}
				}
				else
				{															// starke Nherung
					CPoint2F p2[4];											// 0 ist die Mitte
					float v2[4];

					p2[0]=(p[0]+p[1]+p[2]+p[3])/4;
					v2[0]=(value[0]+value[1]+value[2]+value[3])/4;

					p2[1]=p[1];p2[2]=p[2];p2[3]=p[3];
					v2[1]=value[1];v2[2]=value[2];v2[3]=value[3];
					PlotInnerTriangle(pMC,p2,v2,stepper,col);
					p2[1]=p[2];p2[2]=p[3];p2[3]=p[0];
					v2[1]=value[2];v2[2]=value[3];v2[3]=value[0];
					PlotInnerTriangle(pMC,p2,v2,stepper,col);
					p2[1]=p[3];p2[2]=p[0];p2[3]=p[1];
					v2[1]=value[3];v2[2]=value[0];v2[3]=value[1];
					PlotInnerTriangle(pMC,p2,v2,stepper,col);
					p2[1]=p[0];p2[2]=p[1];p2[3]=p[2];
					v2[1]=value[0];v2[2]=value[1];v2[3]=value[2];
					PlotInnerTriangle(pMC,p2,v2,stepper,col);
				}

			}
		}
	}
}


void CFEMPlotter::DrawEdges( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	CColor rcol=CColor(0x000000);					// Randfarbe

	int i;

	// -- Zeichnen der Dreiecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetTriangleElements();

		for(i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			// Rand zeichnen
			if(el.GetType()==3)											// eET_TRIANGLE
			{
				float x[3],y[3];
				CPoint2F p[3];

				for (int j=0; j<3; j++)
				{
					//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
					//
					int iNodeNr=el.GetNodeNr(i, j)-1;

					assert(iNodeNr >= 0);

					if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
						throw "GetNodeCoord-Error";

					p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						          (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
				}

				pMC->LineAA(p[0].x,p[0].y,p[1].x,p[1].y,255,rcol);
				pMC->LineAA(p[1].x,p[1].y,p[2].x,p[2].y,255,rcol);
				pMC->LineAA(p[2].x,p[2].y,p[0].x,p[0].y,255,rcol);
			}
			else														// eET_TRIANGLE2
			{
				CPoint2F oldpun(0,0);

				// effizienter implementierbar
				for(int j=0;j<4;j++)
				for(float lauf=0.0f;lauf<1.0f;lauf+=1.0f/10)
				{
					float Xi,Eta;

					switch(j)
					{
						default: Xi=lauf;Eta=0.0f;break;
						case 1: Xi=1.0f-lauf;Eta=lauf;break;
						case 2: Xi=0.0f;Eta=1.0f-lauf;break;
					}

					float x[1],y[1];
					double uv[1];
			
					if(!m_femproc.GetFemData().UVInterpolationTriangle(0,i,Xi,Eta,x[0],y[0],uv[0]))break;

					CPoint2F newpun;

					newpun=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
					
					if(j!=0 || lauf!=0.0f)pMC->LineAA(oldpun.x,oldpun.y,newpun.x,newpun.y,255,rcol);

					oldpun=newpun;

					if(j==3)break;
				}

				// frs Debugging
/*				for(float Eta=0.0f;Eta<=1.01f;Eta+=1.0f/10)
				for(float Xi=0.0f;Xi<=1.01f-Eta;Xi+=1.0f/10)
				{
					float x[1],y[1];
					double uv[1];
			
					if(!m_femproc.GetFemData().UVInterpolationTriangle(0,i,Xi,Eta,x[0],y[0],uv[0]))break;

					CPoint2F newpun;

					newpun=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
					
					pMC->CircleAA(newpun.x,newpun.y,2,2,255,0xff0000);
				}
*/			}
		}
	}


	// -- Zeichnen der Vierecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetRectangleElements();

		for(i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			// Rand zeichnen
			if(el.GetType()==4)											// eET_PARALLELOGRAMM
			{
				float x[4],y[4];
				CPoint2F p[4];
				
				for (int j=0; j<4; j++)
				{
					//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
					//
					int iNodeNr=el.GetNodeNr(i, j)-1;

					assert(iNodeNr >= 0);

					if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
						throw "GetNodeCoord-Error";

					p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						          (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
				}
					
				pMC->LineAA(p[0].x,p[0].y,p[1].x,p[1].y,255,rcol);
				pMC->LineAA(p[1].x,p[1].y,p[2].x,p[2].y,255,rcol);
				pMC->LineAA(p[2].x,p[2].y,p[3].x,p[3].y,255,rcol);
				pMC->LineAA(p[3].x,p[3].y,p[0].x,p[0].y,255,rcol);
			}
			else														// eET_PARALLELOGRAMM2
			{
				CPoint2F oldpun(0,0);

				// effizienter implementierbar
				for(int j=0;j<5;j++)
				for(float lauf=0.0f;lauf<1.0f;lauf+=1.0f/10)
				{
					float Xi,Eta;

					switch(j)
					{
						default: Xi=lauf;Eta=0.0f;break;
						case 1: Xi=1.0f;Eta=lauf;break;
						case 2: Xi=1.0f-lauf;Eta=1.0f;break;
						case 3: Xi=0.0f;Eta=1.0f-lauf;break;
					}

					float x[1],y[1];
					double uv[1];
			
					if(!m_femproc.GetFemData().UVInterpolationRectangle(0,i,Xi,Eta,x[0],y[0],uv[0]))break;

					CPoint2F newpun;

					newpun=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
					
					if(j!=0 || lauf!=0.0f)pMC->LineAA(oldpun.x,oldpun.y,newpun.x,newpun.y,255,rcol);

					oldpun=newpun;

					if(j==4)break;
				}

				// frs Debugging
/*				for(float Xi=0.0f;Xi<=1.01f;Xi+=1.0f/10)
				for(float Eta=0.0f;Eta<=1.01f;Eta+=1.0f/10)
				{
					float x[1],y[1];
					double uv[1];
			
					if(!m_femproc.GetFemData().UVInterpolationRectangle(0,i,Xi,Eta,x[0],y[0],uv[0]))break;

					CPoint2F newpun;

					newpun=CPoint2F((x[0]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
						(ho/m_scale-y[0]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
					
					pMC->CircleAA(newpun.x,newpun.y,2,2,255,0xff0000);
				}
*/			}
		}
	}
}

void CFEMPlotter::DrawElementNumbers( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	int i;
	int tri_count=m_femproc.GetFemData().GetTriangleElements().GetCount();

	// -- Zeichnen der Dreiecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetTriangleElements();

		for(i=0;i<tri_count;i++)									// Alle Elemente
		{	
			float x[3],y[3];
			CPoint2F p[3];

			for (int j=0; j<3; j++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				int iNodeNr=el.GetNodeNr(i, j)-1;

				assert(iNodeNr >= 0);

				if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
					throw "GetNodeCoord-Error";

				p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
					         (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
			}

			float mx=(p[0].x+p[1].x+p[2].x)/3.0f;
			float my=(p[0].y+p[1].y+p[2].y)/3.0f;

			char str[80];
			sprintf(str,"%d",i+1);

			// Elementnummer zeichnen
			HDC hdc=pMC->GetHDC();	
			SIZE s;
			SetTextColor(hdc,0x808000);
			SetBkMode(hdc,TRANSPARENT);
			SetTextAlign(hdc,TA_LEFT | TA_NOUPDATECP | TA_TOP);
			GetTextExtentPoint32(hdc,str,strlen(str),&s);
			TextOut(hdc,mx-s.cx*0.5f,my-s.cy*0.5f,str,strlen(str));
			pMC->ReleaseHDC(hdc);
		}
	}


	// -- Zeichnen der Vierecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetRectangleElements();

		for(i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			float x[4],y[4];
			CPoint2F p[4];
			
			for (int j=0; j<4; j++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				int iNodeNr=el.GetNodeNr(i, j)-1;

				assert(iNodeNr >= 0);

				if (m_femproc.GetFemData().GetNodeCoord(iNodeNr, x[j], y[j]) == false)
					throw "GetNodeCoord-Error";

				p[j]=CPoint2F((x[j]-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag,
					          (ho/m_scale-y[j]-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag);
			}

			float mx=(p[0].x+p[1].x+p[2].x+p[3].x)/4.0f;
			float my=(p[0].y+p[1].y+p[2].y+p[3].y)/4.0f;

			char str[80];
			sprintf(str,"%d",tri_count+i+1);

			// Elementnummer zeichnen
			HDC hdc=pMC->GetHDC();	
			SIZE s;
			SetTextColor(hdc,0x808000);
			SetBkMode(hdc,TRANSPARENT);
			SetTextAlign(hdc,TA_LEFT | TA_NOUPDATECP | TA_TOP);
			GetTextExtentPoint32(hdc,str,strlen(str),&s);
			TextOut(hdc,mx-s.cx*0.5f,my-s.cy*0.5f,str,strlen(str));
			pMC->ReleaseHDC(hdc);
		}
	}
}


void CFEMPlotter::DrawNodeNumbers( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	// Schwerpunkt ermitten ( fr einfache Berechnung der besten Position fr den Text )
	int nodecount=m_femproc.GetFemData().GetNodeCount();
	float midx=0.0f,midy=0.0;

	for(int i=0;i<nodecount;i++)
	{
		float x,y;

		if (m_femproc.GetFemData().GetNodeCoord(i, x, y) == false)
					throw "GetNodeCoord-Error";

		midx+=x;midy+=y;
	}
	midx=(midx/nodecount-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag;
	midy=(ho/m_scale-midy/nodecount-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag;

	for(i=0;i<nodecount;i++)
	{
		float x,y;

		if (m_femproc.GetFemData().GetNodeCoord(i, x, y) == false)
					throw "GetNodeCoord-Error";

		float mx=(x-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag;
		float my=(ho/m_scale-y-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag;
		
		float normalx=mx-midx;
		float normaly=my-midy;
		float normal=sqrt(normalx*normalx+normaly*normaly);

		if(normal>0.1f)
		{
			normalx/=normal;
			normaly/=normal;
		}

		char str[80];

		sprintf(str,"%d",i+1);

		// Knotennummer zeichnen
		HDC hdc=pMC->GetHDC();	
		SIZE s;
		SetTextColor(hdc,0x000080);
		SetBkMode(hdc,TRANSPARENT);
		SetTextAlign(hdc,TA_LEFT | TA_NOUPDATECP | TA_TOP);
		GetTextExtentPoint32(hdc,str,strlen(str),&s);
		TextOut(hdc,mx+normalx*11.0f-s.cx*0.5f,my+normaly*11.0f-s.cy*0.5f,str,strlen(str));
		pMC->ReleaseHDC(hdc);
	}
}	



void CFEMPlotter::DrawNodeNumbersOptimized( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float ho=m_rect.bottom-m_rect.top;					// Hhe

	// Schwerpunkt ermitten ( fr einfache Berechnung der besten Position fr den Text )
	int nodecount=m_femproc.GetFemData().GetNodeCount();
	float midx=0.0f,midy=0.0;

	for(int i=0;i<nodecount;i++)
	{
		float x,y;

		if (m_femproc.GetFemData().GetNodeCoord(i, x, y) == false)
					throw "GetNodeCoord-Error";

		midx+=x;midy+=y;
	}
	midx=(midx/nodecount-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag;
	midy=(ho/m_scale-midy/nodecount-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag;

	for(i=0;i<nodecount;i++)
	{
		float x,y;

		if (m_femproc.GetFemData().GetNodeCoord(i, x, y) == false)
					throw "GetNodeCoord-Error";

		float mx=(x-m_subx+m_rect.left/m_scale-pos.x/m_scale)*mag;
		float my=(ho/m_scale-y-m_suby+m_rect.top/m_scale-pos.y/m_scale)*mag;
		
		float normalx=mx-midx;
		float normaly=my-midy;
		float normal=sqrt(normalx*normalx+normaly*normaly);

		if(normal>0.1f)
		{
			normalx/=normal;
			normaly/=normal;
		}

		char str[80];

		sprintf(str,"%d",m_CuthillMcGeeResult[i]+1);

		// Knotennummer zeichnen
		HDC hdc=pMC->GetHDC();	
		SIZE s;
		SetTextColor(hdc,0x000080);
		SetBkMode(hdc,TRANSPARENT);
		SetTextAlign(hdc,TA_LEFT | TA_NOUPDATECP | TA_TOP);
		GetTextExtentPoint32(hdc,str,strlen(str),&s);
		TextOut(hdc,mx+normalx*11.0f-s.cx*0.5f,my+normaly*11.0f-s.cy*0.5f,str,strlen(str));
		pMC->ReleaseHDC(hdc);
	}
}	




void CFEMPlotter::DrawOptimizedMatrix( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float el_width=m_rect.Width()/(float)(m_femproc.GetFemData().GetNodeCount())/m_scale;
	float el_height=m_rect.Height()/(float)(m_femproc.GetFemData().GetNodeCount())/m_scale;

	DWORD *table=m_CuthillMcGeeResult;

	// -- Zeichnen der Dreiecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetTriangleElements();
		int typ=el.GetType();

		for(int i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<typ; j++)
			for (int g=0; g<typ; g++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				float x=table[el.GetNodeNr(i, j)-1];
				float y=table[el.GetNodeNr(i, g)-1];

				CPolVertex p[4];

				p[0].x=(el_width*x + m_rect.left/m_scale-pos.x/m_scale)*mag;
				p[0].y=(el_height*y + m_rect.top/m_scale-pos.y/m_scale)*mag;

				p[1].x=p[0].x + el_width*0.8f*mag;
				p[1].y=p[0].y;
				p[2].x=p[0].x + el_width*0.8f*mag;
				p[2].y=p[0].y + el_height*0.8f*mag;
				p[3].x=p[0].x;
				p[3].y=p[0].y + el_height*0.8f*mag;

				pMC->PolyAA(p,4,0x000000);
			}
		}
	}

	// -- Zeichnen der Vierecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetRectangleElements();
		int typ=el.GetType();

		for(int i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<typ; j++)
			for (int g=0; g<typ; g++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				float x=table[el.GetNodeNr(i, j)-1];
				float y=table[el.GetNodeNr(i, g)-1];

				CPolVertex p[4];

				p[0].x=(el_width*x + m_rect.left/m_scale-pos.x/m_scale)*mag;
				p[0].y=(el_height*y + m_rect.top/m_scale-pos.y/m_scale)*mag;

				p[1].x=p[0].x + el_width*0.8f*mag;
				p[1].y=p[0].y;
				p[2].x=p[0].x + el_width*0.8f*mag;
				p[2].y=p[0].y + el_height*0.8f*mag;
				p[3].x=p[0].x;
				p[3].y=p[0].y + el_height*0.8f*mag;

				pMC->PolyAA(p,4,0x000000);
			}
		}
	}
}



void CFEMPlotter::DrawMatrix( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )
{
	float mag=m_scale/(1<<inMagnify);
	float el_width=m_rect.Width()/(float)(m_femproc.GetFemData().GetNodeCount())/m_scale;
	float el_height=m_rect.Height()/(float)(m_femproc.GetFemData().GetNodeCount())/m_scale;

	DWORD *table=m_CuthillMcGeeResult;

	// -- Zeichnen der Dreiecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetTriangleElements();
		int typ=el.GetType();

		for(int i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<typ; j++)
			for (int g=0; g<typ; g++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				float x=el.GetNodeNr(i, j)-1;
				float y=el.GetNodeNr(i, g)-1;

				CPolVertex p[4];

				p[0].x=(el_width*x + m_rect.left/m_scale-pos.x/m_scale)*mag;
				p[0].y=(el_height*y + m_rect.top/m_scale-pos.y/m_scale)*mag;

				p[1].x=p[0].x + el_width*0.8f*mag;
				p[1].y=p[0].y;
				p[2].x=p[0].x + el_width*0.8f*mag;
				p[2].y=p[0].y + el_height*0.8f*mag;
				p[3].x=p[0].x;
				p[3].y=p[0].y + el_height*0.8f*mag;

				pMC->PolyAA(p,4,0x000000);
			}
		}
	}

	// -- Zeichnen der Vierecks Elemente
	// 
	{
		CFemElement &el=m_femproc.GetFemData().GetRectangleElements();
		int typ=el.GetType();

		for(int i=0;i<el.GetCount();i++)									// Alle Elemente
		{	
			for (int j=0; j<typ; j++)
			for (int g=0; g<typ; g++)
			{
				//-- -1 um Nullindizierte Knotenpunktsnummer zu erhalten
				//
				float x=el.GetNodeNr(i, j)-1;
				float y=el.GetNodeNr(i, g)-1;

				CPolVertex p[4];

				p[0].x=(el_width*x + m_rect.left/m_scale-pos.x/m_scale)*mag;
				p[0].y=(el_height*y + m_rect.top/m_scale-pos.y/m_scale)*mag;

				p[1].x=p[0].x + el_width*0.8f*mag;
				p[1].y=p[0].y;
				p[2].x=p[0].x + el_width*0.8f*mag;
				p[2].y=p[0].y + el_height*0.8f*mag;
				p[3].x=p[0].x;
				p[3].y=p[0].y + el_height*0.8f*mag;

				pMC->PolyAA(p,4,0x000000);
			}
		}
	}
}


void CFEMPlotter::MarkedDraw( I2DMemoryDC *pMC, int r, CPoint2I pos, int inMagnify )
{
	assert(pMC);

	CRect2I rect2;
	CRect2I rect;

	rect.left=		((m_rect.left+1-pos.x)>>inMagnify);
	rect.right=		((m_rect.right-pos.x)>>inMagnify);
	rect.top=		((m_rect.top+1-pos.y)>>inMagnify);
	rect.bottom=	((m_rect.bottom-pos.y)>>inMagnify);

	CPoint2I lefttop=GetWorldPosition();

	pos-=lefttop-CPoint2I(rect.left,rect.top);

	rect2.left=rect.left-r;
	rect2.right=rect.left+r;
	rect2.top=rect.top-r;
	rect2.bottom=rect.top+r;
	pMC->FillRectShade (rect2,0x0);
	rect2.left=rect.right-r;
	rect2.right=rect.right+r;
	rect2.top=rect.top-r;
	rect2.bottom=rect.top+r;
	pMC->FillRectShade (rect2,0x0);
	rect2.left=rect.left-r;
	rect2.right=rect.left+r;
	rect2.top=rect.bottom-r;
	rect2.bottom=rect.bottom+r;
	pMC->FillRectShade (rect2,0x0);
	rect2.left=rect.right-r;
	rect2.right=rect.right+r;
	rect2.top=rect.bottom-r;
	rect2.bottom=rect.bottom+r;
	pMC->FillRectShade (rect2,0x0);
}




ULONG CFEMPlotter::IsAnchorPointAt( int r, CPoint2I xy )	// nur fr markierte Objekte, 0, wenn dort kein Punkt, sonst ist dort ein Angriffspunkt (Skalieren, ...)
{
/*	CRect2I rect2;

	CPoint2I lefttop=GetWorldPosition();

	CPoint2I pos=CPoint2I(m_rect.left,m_rect.top)-lefttop;

	rect2.left=m_rect.left-r-pos.x;
	rect2.right=m_rect.left+r-pos.x;
	rect2.top=m_rect.top-r-pos.y;
	rect2.bottom=m_rect.top+r-pos.y;
	if(rect2.PtInRect(xy))return(1);
	rect2.left=m_rect.right-r-pos.x;
	rect2.right=m_rect.right+r-pos.x;
	rect2.top=m_rect.top-r-pos.y;
	rect2.bottom=m_rect.top+r-pos.y;
	if(rect2.PtInRect(xy))return(2);
	rect2.left=m_rect.left-r-pos.x;
	rect2.right=m_rect.left+r-pos.x;
	rect2.top=m_rect.bottom-r-pos.y;
	rect2.bottom=m_rect.bottom+r-pos.y;
	if(rect2.PtInRect(xy))return(3);
	rect2.left=m_rect.right-r-pos.x;
	rect2.right=m_rect.right+r-pos.x;
	rect2.top=m_rect.bottom-r-pos.y;
	rect2.bottom=m_rect.bottom+r-pos.y;
	if(rect2.PtInRect(xy))return(4);
*/
	return(0);
}





I2DDraw *CFEMPlotter::GetTopObjectAt( CPoint2I xy )
{
	if(IsObjectAt(xy))return(this);

	return(CDocObject::GetTopObjectAt(xy));
/*
	ISceneGraphObject *p=GetIn().GetPtr();
	I2DDraw *top=this;

	for(;p!=0;p=p->GetNext().GetPtr())
	{
		I2DDraw *m=(I2DDraw *)p->QueryInterface(eI2DDraw);

		I2DDraw *here=m->GetTopObjectAt(xy-CPoint2I(m_rect.left,m_rect.top));

		if(here)top=here;
	}
	return(top);
*/
}

I2DDraw *CFEMPlotter::GetTopAnchorPointAt( int r, CPoint2I xy, ULONG &anchorid )
{
	anchorid=IsAnchorPointAt(r,xy);

	if(anchorid!=0)return(this);

	return(CDocObject::GetTopAnchorPointAt(r,xy,anchorid));
/*
	ISceneGraphObject *p=GetIn().GetPtr();
	I2DDraw *top=this;

	for(;p!=0;p=p->GetNext().GetPtr())
	{
		I2DDraw *m=(I2DDraw *)p->QueryInterface(eI2DDraw);

		I2DDraw *here=m->GetTopObjectAt(xy-CPoint2I(m_rect.left,m_rect.top));

		if(here)top=here;
	}
	return(top);
*/
}


void CFEMPlotter::OnContextMenu( IPopUpMenu *k, CPoint2I xy )
{
	IPopUpMenu *p=MakeCreateMenu(k,xy);


	k->AppendMenu("Create",p);

	{
		char idstr[80];

		sprintf(idstr,"Delete(%p)",(ISceneGraphObject *)this);

		k->AppendItem("Delete",idstr);
	}
	

	k->TrackPopUpMenu();

	p->Release();
}


// hier wird nur das zu serialisierende Objekt betrachtet,
// nicht Objekte auf die das Objekt werweist oder beinhaltet.
void CFEMPlotter::Serialize( CSerializeArchivePointer &ar )
{
	// if(ar.GetMode==CSAM_saveADEF) ....

/*	ar.Dint(m_rect.left,"left");
	ar.Dint(m_rect.top,"top");
	ar.Dint(m_rect.bottom,"bottom");
	ar.Dint(m_rect.right,"right");

*/
	CDocObject::Serialize(ar);		// Vaterobjekt serialisieren (nur wenn erwnscht)
}



void CFEMPlotter::OnControlMessage( struct CRGUI_ControlMessage &m )
{
	try
	{
		switch(m.Cmd)
		{
			case cmd_ValueChanged:
				{
	//				bool redraw=false;
					ULONG val;

					bool redraw=true;
					
					switch(m.Caller_UserId)
					{
						case eDisplayU:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[0]=val==1;
							}
							break;
						case eDisplayV:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[1]=val==1;
							}
							break;
						case eDisplayElements:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[2]=val==1;
							}
							break;
						case eDisplayNodes:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[3]=val==1;
							}
							break;
						case eDisplayEdges:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[4]=val==1;
							}
							break;
						case eDisplayMatrix:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[5]=val==1;
							}
							break;
						case eDisplayNodesOptimized:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[6]=val==1;
							}
							break;
						case eHighQualityInterpolation:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[7]=val==1;
							}
							break;
						case eDisplayMatrixOptimized:
							{
								m.Caller_Ptr->GetValue(val);m_displayValues[8]=val==1;
							}
							break;
						case eStepperU:
							{
								char str[256];

								m.Caller_Ptr->GetText(str,256);

								if(sscanf(str,"%f",&m_StepperU)!=1)
									m_StepperU=1;
							}
							break;
						case eStepperV:
							{
								char str[256];

								m.Caller_Ptr->GetText(str,256);

								if(sscanf(str,"%f",&m_StepperV)!=1)
									m_StepperV=1;
							}
							break;
					}

					if(redraw)
					{
						// Redraw
						CHandle<ISceneGraphObject> par=GetTopmostParent();
						if(par)
						{
							CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
							if(ro)
							{
								ro->RedrawAll();
							}
						}
					}
				}
				break;

			case cmd_Trigger:								// z.B. Button pressed oder Menauswahl
				switch(m.Caller_UserId)
				{
					case eLoeschen:				m_MainGUIDialog->ReleaseWindow();ReleaseObject();Release();break;
					case eOpenFEMIN:			OpenFEMIN();break;
					case eOpenFEMOUT:			OpenFEMOUT();break;
					case eCalcAndSave_Array:	CalcAndSave_Array();break;
					case eCalcAndSave_Hull:		CalcAndSave_Hull();break;
					case eCalcAndSave_List:		CalcAndSave_List();break;
					case eSubdiv:				Subdiv();break;
	/*				case eNew:					NewDocument();RefreshStatusLine();break;
					case eQuit:					DestroyWindow(hMainWnd);break;				// Hauptfenster zerstren beendet die Applikation
					case eSaveFile:				SaveFile();break;
					case eSaveAsFile:			SaveAsFile();break;
					case eOpenFile:				OpenFile();break;

					case eImportExplorer:		ImportExplorer();break;
					case eImportNetscapeTxt:	ImportNetscapeTxt();break;

					case eAnsichtBearbeiten:	AnsichtBearbeiten();break;
					
					case eExportHTML1:			ExportHTML1();break;
	*/
					default:	MessageBox(0,"Not Done","Message",MB_OK);
				}

				break;

			case cmd_DialogMessage:							// Debugging
	//			sprintf(str,"ApplicationGetsMessage: Dialog Message %s",m.String_Ptr);
	//			AddConsoleLine(str);
				break;

			case cmd_Open:			// fr Tree
				break;

			case cmd_Close:			// fr Tree
				break;

			default:
				MessageBox(0,"Unknown Control Message","Error",MB_OK);
		}
	}
	catch(char *txt)
	{
		MessageBox(0,txt,"Error",MB_OK);
	}
	catch(...)
	{
		MessageBox(0,"?","Error",MB_OK);
	}

}



void CFEMPlotter::OpenFEMIN( void )
{
	char back[1024];
	if(GetCurrentDirectory(1024,back)==0)
	{
		ERR->Add("CFEMPlotter::OpenFEMIN failed");
		MessageBox(0,"GetCurrentDirectory","failed",MB_OK);
		return;
	}

	char filestr[1024];		filestr[0]=0;

	CGUIAppData gapp;

	g_App->GetGUIAppData(gapp);

	OPENFILENAME ofn;

	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=gapp.m_hMainFrame;
	ofn.hInstance=gapp.m_hInstance;
	ofn.lpstrFilter="Alle Dateien  (*.*)\0*.*\0";
	ofn.lpstrCustomFilter = (LPTSTR)NULL;
	ofn.nMaxCustFilter = 0L;
	ofn.nFilterIndex = 1L;
	ofn.lpstrInitialDir=NULL;
	ofn.lpstrTitle="Whlen der FEMIN Quelldatei";

	ofn.lpstrFileTitle=0;
	ofn.nMaxFileTitle=0;

	ofn.lpstrFile=filestr;
	ofn.nMaxFile=sizeof(filestr);

	ofn.lCustData=0;
	ofn.lpstrDefExt=".txt";
	ofn.Flags=OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ENABLESIZING;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;

	if(GetOpenFileName(&ofn))
	{
		try
		{
			delete [] m_CuthillMcGeeResult;m_CuthillMcGeeResult=0;

			InitVar();

			m_femproc.LoadFemIn(filestr);

			CalcCuthillMcGee();

			float minx,maxx,miny,maxy;

			m_femproc.GetMinMaxCoord(minx,maxx,miny,maxy);

			float br=(maxx-minx)*m_scale;
			float ho=(maxy-miny)*m_scale;

			m_subx=(maxx+minx)/2			- (maxx-minx)/2;
			m_suby=-(maxy+miny)/2			+ (maxy-miny)/2;

			SetRect(CRect2I(m_rect.left,m_rect.top,m_rect.left+br,m_rect.top+ho));

			CHandle<ISceneGraphObject> par=GetTopmostParent();
			assert(par);
			CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
			assert(ro);
			ro->RedrawAll();


			UpdateControlWindow();
		}
		catch(CFemDataError &e)
		{
//			cout << e.GetLineNr() << " Error: " << e.GetMessage() << endl;
			ERR->Add("Parse Error at line: %d     Error: %s",e.GetLineNr(),e.GetErrorMessage());
		}


		CalcCuthillMcGee();	
	}

	SetCurrentDirectory(back);
}





void CFEMPlotter::OpenFEMOUT( void )
{

	char back[1024];
	if(GetCurrentDirectory(1024,back)==0)
	{
		ERR->Add("CFEMPlotter::OpenFEMOUT failed");
		MessageBox(0,"GetCurrentDirectory","failed",MB_OK);
		return;
	}


	char filestr[1024];		filestr[0]=0;

	CGUIAppData gapp;

	g_App->GetGUIAppData(gapp);

	OPENFILENAME ofn;

	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=gapp.m_hMainFrame;
	ofn.hInstance=gapp.m_hInstance;
	ofn.lpstrFilter="Alle Dateien  (*.*)\0*.*\0";
	ofn.lpstrCustomFilter = (LPTSTR)NULL;
	ofn.nMaxCustFilter = 0L;
	ofn.nFilterIndex = 1L;
	ofn.lpstrInitialDir=NULL;
	ofn.lpstrTitle="Whlen der FEMOUT Quelldatei";

	ofn.lpstrFileTitle=0;
	ofn.nMaxFileTitle=0;

	ofn.lpstrFile=filestr;
	ofn.nMaxFile=sizeof(filestr);

	ofn.lCustData=0;
	ofn.lpstrDefExt=".txt";
	ofn.Flags=OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ENABLESIZING;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;

	if(GetOpenFileName(&ofn))
	{
		try
		{
			m_femproc.GetFemData().LoadFemOut(filestr);

			CHandle<ISceneGraphObject> par=GetTopmostParent();
			assert(par);
			CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
			assert(ro);
			ro->RedrawAll();

		}
		catch(CFemDataError &e)
		{
			ERR->Add("Parse Error at line: %d     Error: %s",e.GetLineNr(),e.GetErrorMessage());
		}
	}

	SetCurrentDirectory(back);
}


void CFEMPlotter::CalcAndSave_Array( void )
{
	DWORD memneeded;

	if(m_femproc.GetFemData().GetFEMVersion()>=4)
		m_femproc.StartCalculation_MatrixNMArray_EW(memneeded);
	  else
		m_femproc.StartCalculation_MatrixNMArray(memneeded);

	m_femproc.GetFemData().SaveFemOut(0);					// unter dem Namen aus der FEMIN Datei

	// Redraw
	CHandle<ISceneGraphObject> par=GetTopmostParent();
	assert(par);
	CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
	assert(ro);

	ro->RedrawAll();

	// Display updaten
	char str[256];
	IWinGUIButton *n;

	n=m_MainGUIDialog->GetPtrFromUserId(eMemoryOutput);assert(n);
	sprintf(str,"Speicher: %d Bytes (Array)",memneeded);
	n->SetText(str);
}




void CFEMPlotter::CalcAndSave_Hull( void )
{
	DWORD memneeded;

	m_femproc.StartCalculation_MatrixNMHull(m_CuthillMcGeeResult,memneeded);

	m_femproc.GetFemData().SaveFemOut(0);					// unter dem Namen aus der FEMIN Datei

	// Redraw
	CHandle<ISceneGraphObject> par=GetTopmostParent();
	assert(par);
	CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
	assert(ro);

	ro->RedrawAll();

	// Display updaten
	char str[256];
	IWinGUIButton *n;

	n=m_MainGUIDialog->GetPtrFromUserId(eMemoryOutput);assert(n);
	sprintf(str,"Speicher: %d Bytes (Hull)",memneeded);
	n->SetText(str);
}

void CFEMPlotter::CalcAndSave_List( void )
{
//	MessageBox(0,"Not Done","Message",MB_OK);

	DWORD memneeded;

	m_femproc.StartCalculation_MatrixNMList(memneeded);

	m_femproc.GetFemData().SaveFemOut(0);					// unter dem Namen aus der FEMIN Datei

	// Redraw
	CHandle<ISceneGraphObject> par=GetTopmostParent();
	assert(par);
	CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
	assert(ro);

	ro->RedrawAll();


	// Display updaten
	char str[256];
	IWinGUIButton *n;

	int nc=m_femproc.GetFemData().GetNodeCount();

	n=m_MainGUIDialog->GetPtrFromUserId(eMemoryOutput);assert(n);
	sprintf(str,"Speicher: %d Bytes (List)",memneeded);
	n->SetText(str);
}


// nicht skalierbar
void CFEMPlotter::ScaleObject( CPoint2I rel )
{
}

void CFEMPlotter::Subdiv( void )
{
	delete [] m_CuthillMcGeeResult;m_CuthillMcGeeResult=0;


	m_femproc.QuadSubDivision();

	CalcCuthillMcGee();


	// Redraw
	CHandle<ISceneGraphObject> par=GetTopmostParent();
	assert(par);
	CHandle<ISceneGraphRootObject> ro=GETINTERFACE(par,ISceneGraphRootObject);
	assert(ro);

	ro->RedrawAll();

	UpdateControlWindow();
}

void CFEMPlotter::UpdateControlWindow( void )
{
	char str[256];
	IWinGUIButton *n;

	int nc=m_femproc.GetFemData().GetNodeCount();

	n=m_MainGUIDialog->GetPtrFromUserId(eNodeCountOutput);assert(n);
	sprintf(str,"Knotennanzahl: %d",nc);
	n->SetText(str);

	n=m_MainGUIDialog->GetPtrFromUserId(eMemoryOutput);assert(n);
	sprintf(str,"Speicher: ---");
	n->SetText(str);
}
