//-- Definition von Konstanten Daten
//
#ifndef _FEM_CONSTANTS_H__
#define _FEM_CONSTANTS_H__

#include "FemCoord.h"

/*! \file FemConstants.h
    \brief Global constants and datatypes for FEM-Data
*/

/*!
  \def FP_TYPE is the replacement for the used datatype
*/
#define FP_TYPE double




// 6x6 krummlinige Elementrnder A
const FP_TYPE A_tri_krum[]={  1, 0, 0, 0, 0, 0,
							 -3,-1, 0, 4, 0, 0,
							 -3, 0,-1, 0, 0, 4,
							  2, 2, 0,-4, 0, 0,
							  4, 0, 0,-4, 4,-4,
							  2, 0, 2, 0, 0,-4 };


// 6x6 krummlinige Elementrnder B=A.Inverse()
/*
	CMatrixNMArray<double> mat(6,6,A_tri_krum);
	CMatrixNMArray<double> A_tri_krum;

	B_tri_krum.Inverse(mat);
*/


// 8x8 krummlinige Elementrnder A
const FP_TYPE A_rect_krum[]={ 1, 0, 0, 0, 0, 0, 0, 0,
							 -3,-1, 0, 0, 4, 0, 0, 0,
							 -3, 0, 0,-1, 0, 0, 0, 4,
							  2, 2, 0, 0,-4, 0, 0, 0,
							  5,-1,-3,-1,-4, 4, 4,-4,
							  2, 0, 0, 2, 0, 0, 0,-4,
							 -2,-2, 2, 2, 4, 0,-4, 0,
							 -2, 2, 2,-2, 0,-4, 0, 4 };

// 8x8 krummlinige Elementrnder B=A.Inverse()
/*
	CMatrixNMArray<double> mat(8,8,A_rect_krum);
	CMatrixNMArray<double> B_rect_krum;

	B_rect_krum.Inverse(mat);
*/

//-- Hilfsarray mit den Zwischenpunkten fr die Netzverfeinerung von FEM3-Gebieten
//   Die Koordinaten beziehen sich auf das Einheitselement.
//
const tagCoord g_TRI2_MainSamples[]=
{
    {0.25, 0   },   // Linke untere Ecke als Ausgangspunkt
    {0   , 0.25},
    {0.75, 0.25},   // Rechte untere Ecke als Ausgangspunkt
    {0.75, 0   },
    {0   , 0.75},   // Linke obere Ecke als Ausgangspunkt
    {0.25, 0.75}
};

const tagCoord g_RECT2_MainSamples[]=
{
    {0.25, 0   },   // Linke untere Ecke als Ausgangspunkt
    {0   , 0.25},
    {1   , 0.25},   // Rechte untere Ecke als Ausgangspunkt
    {0.75, 0   },
    {0.75, 1   },   // Rechte obere Ecke als Ausgangspunkt
    {1   , 0.75},
    {0   , 0.75},   // Linke obere Ecke als Ausgangspunkt
    {0.25, 1   }
};

#endif//_FEM_CONSTANTS_H__