//-------------------------------------------------------------------+
// FemEWHelper.h                                                     |
//-------------------------------------------------------------------+
// Author: Tobias Lang                                               |
//-------------------------------------------------------------------+
// (c) Copyright 2001 by Tobias Lang & Martin Mittring               |
//-------------------------------------------------------------------+ t.l. 07.06.2001
#ifndef _DVA_FEM_EW_HELPER_H__
#define _DVA_FEM_EW_HELPER_H__

//! Hilfsklasse fr die Auswertung der berechneten Eigenwerte in CFemProcessor.
//
class CEWHelper
{
public:
    FP_TYPE     m_fEWValue;         //! Eigenwert
    int         m_iEVIndex;         //! Nullindizierter Index auf den Eigenvektor bzw. Index des EW in der Hauptdiagonalen

public:
    CEWHelper():m_fEWValue(0),m_iEVIndex(0)
    {}

    //! Vergleichsoperator fr stl-sort Templatefunktion
    int operator() (CEWHelper &lhs, CEWHelper &rhs)
    {
        return lhs.m_fEWValue<rhs.m_fEWValue;
    }
};


class CEWInverseHelper
{
public:
    //! Vergleichsoperator fr stl-sort Templatefunktion
    int operator() (CEWHelper &lhs, CEWHelper &rhs)
    {
        return lhs.m_fEWValue>rhs.m_fEWValue;
    }
};


#endif//_DVA_FEM_EW_HELPER_H__