//-------------------------------------------------------------------+
// FemHistory.h                                                      |
//-------------------------------------------------------------------+
// History from the DVA Finite Elemente Project                      |
//-------------------------------------------------------------------+
// (c) Copyright 2001 by Tobias Lang                                 |
//-------------------------------------------------------------------+ t.l. 31.01.2001
#ifndef _DVA_FEM_HISTORY_H__
#define _DVA_FEM_HISTORY_H__

const char g_pFEMTimeStamp[]=__TIMESTAMP__;

//----------------------------------------------------------------------------------------+
// HISTORY                                                                                |
//                                                                                        |
// Legende: (*: work), (-: to do), (#: to do, was finished later)                         |
//----------------------------------------------------------------------------------------+
//
// 30.01.01: * Projekt DVA Finite Elemente begonnen
//           * FemData.h, FemEdge.h, FemData.cpp und main.cpp erstellt
//
// 31.01.01: * FemHistory.h erstellt
//           # Parserklasse entwickeln
//           * FemDataError.h, TokenParser.h, TokenParser.cpp erstellt
//
// 01.02.01: * Laderoutine CFemData::LoadFemIn abgeschlossen (zumindest fr FEM-Version 2)
//           * FemElement.h erstellt
//           # Zugriffsmethoden von CFemData implementieren
//
// 02.02.01: * GetMethoden in CFemData implementiert
//           # SetMethoden in CFemDate einbauen
//           # Speicherroutine fr FEMOUT und FEMIN-Dateien implementieren
// 
// 06.02.01: * Matrix und Vektor Klassen von M.M. integriert
//
// 08.02.01: * 1. Calc-Version von M.M.
//           * Commando-Stack fr RB in CFemData hinzugefgt
//           * Coord-Bezeichnungen der Variablen und Methoden
//             in CFemEdge und CFemElement nach Node umbenannt
//           # CFemProcessor-Klasse fr die Kapselung der Berechnungen implementieren
//
// 09.02.01: * Lade- und Speicherroutine fr FEMOUT-Dateien implementiert
//           * FEMOUT-Speicher-Funktion implementiert
//           * FemData mit mehreren FEM-Dateien getestet
//           * Parallelogramm-Support eingebaut
//           * main.cpp um einfachen Komandozeileninterpreter ergnzt
//           # Parallelogramm-Test durchfhren
//
// 16.02.01: * BUG: in CFemData::FreeData() wurde die Calculation-Klasse nicht Deinitialisiert.
//
// 22.02.01: * Fr tagCoord-struct eine eigene Header-Datei FemCoord.h erstellt
//           * CCalc-Klasse nach CFemCalc umbenannt und in separate Headerdatei kopiert
//           * statisches Array fr die Koordinaten durch stl-vector ersetzt
//           * CFemElement fr Netzverfeinerung vorbereitet:
//             Hilfsmethoden GetEdgeCount + GetEdge implementiert
//           * Funktion in CFemProcessor fr "Krzeste Kante im Netz suchen" hinzugefgt
//
// 28.02.01: * CFemElement auf vector umgestellt
//           * BackInsertNode in CFemData hinzugefgt
//           # CFemElement::QuadSubDivision implementieren
//
// 01.03.01: # Probleme mit stl-vector-Klasse! Die Reihenfolge der Elemente wird anscheinend nicht garantiert!
//             => eigene stl-vector-Klasse implementieren
//           # Laden der neu generierte FEMIN-Datei schlgt anscheinend fehl (zumindest mit dem Viewer von Martin)
//             => eigene Tests fahren
//           # stl-vector-Klasse zum Test nochmals gegen echte stl-Klasse austauschen ([]-operator knnte
//             das Problem gewesen sein)
//           # In FemEdge eine Insert-Funktion einbauen
//           # Beim Verfeinern des Gebietes mssen die Rnder bercksichtigt werden!
//             Algorithmus: Ist die aktuelle Kante ein Rand, falls ja Zwischenpunkt dem Rand hinzufgen
//           * Laden der neu generierten FEMIN-Datei funktioniert mit der Konsolenapplikation
//           - Ab ca. 2000 Knotenpunkte bentigt die Applikation ca. 80 MByte Speicher und 5 Minuten Rechenzeit
//             => Wre interessant wenn man feststellen knnte welche Komponenten wieviel Speicher verbrauchen
//
// 02.03.01: * Rnder werden bei der Gebietsverfeinerung nun auch beachtet!
//           # Elemente mit vier Eckpunkten werden noch nicht verfeinert!
//
// 10.03.01: * BUG: Nach dem Verfeinern des Gebietes wurde das UV-Array in CFemData nicht auf die
//                  neue Knotenpunktanzahl angepasst!
//           * BUG: In CFemData::LoadFemIn sind die UV-Werte nicht initialisiert gewesen. Nun
//                  werden sie auf Null gesetzt. Ob sich das auf die Darstellung auswirkt ist nicht bekannt?
//           * Get/SetUVValue melden eine assert-warnung, falls der Index ungltig ist.
//           * BUG: Es wurden zu viele Knotenpunkte bei der Verfeinerung des FEM-Gebietes erzeugt.
//                  Diejenigen Kanten, die bereits halbiert wurden und dafr ein neuer Knotenpunkt generiert
//                  wurde, sind doppelt halbiert worden. Dadurch sind Knotenpunkte doppelt generiert worden.
//                  => CFemGeoEdge::Compare musste korregiert bzw. durch CompareStrong erweitert werden
//                  => CFemProcessor::SubDivsion arbeitete auf einer Kopie von CFemGeoEdge statt einer Referenz
//           * STL: Das Problem mit der vector-Klasse ist nun geklrt: Elemente drfen nicht mit dem
//                  []-Operator in einen noch nicht belegten vector eingefgt werden!
//
// 21.03.01: * Die Hilfsfunktion CFemProcessor::ElementQuadSubDivision implementiert. Damit wird
//             die Verfeinerung von unterschiedlichen Elementtypen vereinfacht.
//           # CFemElement::QuadSubDivision soweit anpassen, dass auch Parallelogramm bzw. Viereckselemente
//             bercksichtigt werden.
//
// 27.03.01: * Elemente mit vier Eckpunkten knnen nun auch ber die Gebietsverfeinerung in
//             weitere Elemente unterteilt werden.
//           # Elemente mit Zwischenpunkte und krummlienigen Kanten werden derzeit nicht untersttzt.
//
// 03.04.01: * Zwischeninterpolation von beliebigen Punkten eines Elements in CFemData hinzugefgt:
//             UVInterpolationXXX(..)
//           # Test der obigen Funktion
//
// 04.04.01: * Zwischeninterpolation etwas korrigiert (m.m.)
//           * Darstellung mit Zwischeninterpolation (High Quality) (m.m.)
//           * FEM Berechnung geht nun mit auch mit MatrixNMHull
//           * FEM Berechnung mit MatrixNMList steht noch aus
//
// 24.04.01: * CFemData::LoadFemIn an das FEM3-Format angepasst.
//           # Behandlungsroutinen auf das FEM3-Datenformat anpassen.
//
// 03.05.01: * CMatrixNMArray(z,s,const T *) liest nun nicht mehr transponiert (fiel vorher wg.
//             Symmetrie nicht auf ) (m.m.)
//           * Inverse in MatrixNMArray aufgenommen (m.m.)
//           * A_rect_krum, A_tri_krum zu FEMConstants hinzugefgt (m.m.)
//           * CalcCuthillMcGee auf krummlinige Element umgestellt (m.m.)
//           * CFEMPlotter::Draw Aufgesplittet in 6 Methoden wg. bersichtlichkeit 
//           # Darstellung krummliniger Elemente
//           # Elementsteifigkeitsmatrix krummliniger Elemente berechnen
//
// 13.05.01: * Netzverfeinerung auf FEM3-Format angepasst
// 
// 29.05.01: * Matrixmultiplikation in CMatrixNMArray war falschrum definiert
//
// 04.06.01: * EW-Berechungen in Prozessor und MatrixNMArray hinzugefgt
//           * try/catch Blcke in FEMPlotter integriert (MessageBox Ausgabe)
//           * nun werden auch Gebiete mit negativen Koordinaten richtig zentriert dargestellt
//
// 07.06.01: * EW-Helper-Klasse erstellt (FemEWHelper.h)
//           * Log-File-Ausgaben in CFemProcessor angepasst, LogFile wird jetzt in Abhngigkeit
//             der Eingabedatei benannt.
//
// 14.06.01: * Load/Save von Fem-Dateien fr Eigenwerte erweitert und angepasst.
//           * Matrixdarstellungin FEMPlotter nun immer quadratisch (m.m.)
//           * Antialiased Darstellung Lines nun besser, etwas optimiert (m.m.)
//           * Applikation nun gleich maximized (m.m.)
//
//
//----------------------------------------------------------------------------------------+



#endif //_DVA_FEM_HISTORY_H__