#ifndef _DVA_FEM_TIMER_H__
#define _DVA_FEM_TIMER_H__

#include <iostream>
#include "PerfTimer.h"


/*!
    \brief Vereinfacht die Zeitmessung von Programmabschnitten.
    \author Tobias Lang
    \version 1.0
    \date    2001
*/
class CFemTimer
{
private:
    const char* m_pSectionDescription;  //!< Beschreibung der Zeitmessung.
    CPerfTimer& m_perfTimer;            //!< Referenz auf einen initialierten Performance-Timer

public:
    //! Ein CFemTimer kann nur mit diesem Konstruktor erzeugt werden. Die Zeitmessung beginnt mit der Erzeugung des Objekts.
    //! \param in_pSection Beschreibung des zu messenden Abschnitts.
    //! \param in_perfTimer Initialiserter Performance-Timer.
    CFemTimer(const char* in_pSection, CPerfTimer& in_perfTimer):
      m_pSectionDescription(in_pSection),
      m_perfTimer(in_perfTimer)
    {
        m_perfTimer.BeginStop();
    }

    //! Mit der Zerst&ouml;rung des Objektes wird die Zeitmessung beendet.
    ~CFemTimer()
    {
        cout << m_pSectionDescription << " " << m_perfTimer.EndStop() << " ms" << endl;
    }
};

#define START_TIMER(_SECTION_, _PERF_TIMER_) { CFemTimer _femTimer(_SECTION_, _PERF_TIMER_);
#define END_TIMER() }

#endif//_DVA_FEM_TIMER_H__