// 
//  Eintrittspunkt der Applikation
//

#include <iostream>
#include "FemProcessor.h"
#include "FemHistory.h"

#include "PerfTimer.h"
#include "FemTimer.h"

//-- argc==1 => keine Parameter (bis auf Dateiname)
//   argv[0] => Dateiname der Executeable mit vollstndigem Pfad
//
int main(int argc, char *argv[])
{
    cout << "DVA-Methode der Finiten Elemente, "
         << "Buildversion: " << g_pFEMTimeStamp << endl << endl;

    CPerfTimer perfTimer;
    if (perfTimer.Init()==false)
        cout << "Timer not available!" << endl;

    CFemProcessor femProcessor(&perfTimer);
    string sFemInFile;
    string sFemOutFile;


    try
    {
        if (argc >=2 )
        {
            sFemInFile=argv[1];
            int spos=sFemInFile.rfind(".");
            if (spos != string::npos)
            {
                sFemOutFile=sFemInFile.substr(0, spos+1);
                sFemOutFile.append("out");
            }
        }
        else
        {
            //-- Try to load default-files
            //
            sFemInFile="FemFile.in";
            sFemOutFile="FemFile.out";
        }

        femProcessor.LoadFemIn(sFemInFile.c_str());
        femProcessor.GetFemData().SaveFemIn("ksjdfk.in");
        return 0;

        CVectorNArray<FP_TYPE>  vEigenWerte;
        CMatrixNMArray<FP_TYPE> mEigenVektoren;

        femProcessor.LoadFemIn(sFemInFile.c_str());
        if (femProcessor.GetFemData().ExternOutDataAvailable())
            cout << "Found FEM-Out-file\n";

        DWORD dwMemory;
        femProcessor.StartCalculation_MatrixNMArray_EW(dwMemory, vEigenWerte, mEigenVektoren);

        femProcessor.GetFemData().SaveFemOut(femProcessor.GetFemData().GetFEMOutFileName(), &vEigenWerte, &mEigenVektoren);

        return 1;

        /*
        unsigned long lSize;
        femProcessor.StartCalculation_MatrixNMArray(lSize);


        femProcessor.GetFemData().SaveFemOut(sFemOutFile.c_str());
        cout << sFemOutFile << " output-file generated" << endl << endl;
        */

        //-- nur test
        //

        /* Test der krzesten Kante
        {
            CFemElement::eElementType eLeftType, eRightType;
            int iLeftElement, iRightElement, iStartPnt, iEndPnt;

            if (femProcessor.GetShortestEdge(eLeftType, iLeftElement, eRightType, iRightElement, iStartPnt, iEndPnt))
                cout << "LeftType : " << eLeftType  << ", LeftElement : " << iLeftElement  << endl
                     << "RightType: " << eRightType << ", RightElement: " << iRightElement << endl
                     << "StartPnt : " << iStartPnt  << ", EndPnt      : " << iEndPnt       << endl;
            else
                cout << "keine Kante gefunden" << endl;

            cout << endl;
        }
        */

        /* Test von MinMax
        {
            float minX, maxX, minY, maxY;
            if (femProcessor.GetMinMaxCoord(minX, maxX, minY, maxY))
            {
                cout << "MinX: " << minX << " " << "MaxX: " << maxX << endl
                     << "MinY: " << minY << " " << "MaxY: " << maxY << endl;
            }
        }
        */

        //* SubDivision-Test
        {
            cout << "Beginne mit der Netzverfeinerung, Anzahl der Knotenpunkte: "
                 << femProcessor.GetFemData().GetNodeCount()
                 << endl;

            START_TIMER("\nTime SubDivision", perfTimer)
                femProcessor.QuadSubDivision();
            END_TIMER()
            femProcessor.GetFemData().SetFEMOutFileName("sub_membran.out");
            femProcessor.GetFemData().SaveFemIn("sub_membran.in");

            cout << "Anzahl der Knotenpunkte nach der Verfeinerung: "
                 << femProcessor.GetFemData().GetNodeCount()
                 << endl;
        }
        //*/

        //
        //-- bis hier test
    }
    catch(CFemDataError &e)
    {
        cout << e.GetLineNr() << " Error: " << e.GetErrorMessage() << endl;
    }
    catch(char *e)
    {
        cout << e << endl;
    }
    /*
    catch(...)
    {
        cout << "Fataler Fehler" << endl;
    }
    */
    return 0;
}
