// DocObject.h: Schnittstelle fr die Klasse CDocObject.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOCOBJECT_H__F994F94D_CD3F_11D3_BD1F_0000B465D2C5__INCLUDED_)
#define AFX_DOCOBJECT_H__F994F94D_CD3F_11D3_BD1F_0000B465D2C5__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\..\shared\CComponentBase.h"
#include "..\..\shared\Interfaces.h"
#include "ISimpleBox.h"
#include "assert.h"				// assert.h

#include "..\..\shared\SerializeArchivePointer.h"	// CSerializeArchivePointer
#include "..\..\PlugInSource\GraphLib\DGraphLib.h"	// CRect2I


// das hier erspart so manchen include
class CMC;
class CSerializeArchive;

// hiervon leiten sich die anderen ab, Instanzen dieser Klasse kann man nicht erstellen

//CLASS(CDocObject)		// Interfaces and parent    are defines in objects.h
class CDocObject : public CComponentBase, public I2DDraw, public virtual ISceneGraphObject, 
				   public ISerialize
{
	public:
		CDocObject();
		virtual ~CDocObject();

	CHandle<ISceneGraphObject>			GetTopmostParent	( void );		// reine Komfortfunktion

	/////////////////////////////////////////////////////////////////////////////
	// Membervariablen
	//

	IPopUpMenu *						MakeCreateMenu		( IPopUpMenu *p, CPoint2I xy );

	// Interface I2DDraw
	virtual	CRect2I						GetRect				( void );
	virtual	void						SetRect				( const CRect2I &r );
	virtual void						Draw				( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify );
	virtual void						MoveObject			( CPoint2I rel, ULONG &AnchorPoint );
	virtual void						MarkedDraw			( I2DMemoryDC *pMC, int r, CPoint2I pos, int inMagnify );	// wird zusttzlich zu Draw aufgerufen, wenn Objekt markiert ist
	virtual bool						IsObjectAt			( CPoint2I xy );
	virtual I2DDraw *					GetTopObjectAt		( CPoint2I xy );
	virtual	void						OnContextMenu		( IPopUpMenu *p, CPoint2I xy )=0;
	virtual	CPoint2I					GetWorldPosition	( void );		// arbeitet rekursiv
	virtual void						ScaleObject			( CPoint2I rel );
	virtual ULONG						IsAnchorPointAt		( int r, CPoint2I xy );	// nur fr markierte Objekte, 0, wenn dort kein Punkt, sonst ist dort ein Angriffspunkt (Skalieren, ...)
	virtual I2DDraw *					GetTopAnchorPointAt ( int r, CPoint2I xy, ULONG &anchorid );	// arbeitet rekursiv,id von 1 bis ...
	
	// Interface ISceneGraphObject
	virtual CHandle<ISceneGraphObject>	GetParent			( void )					{ return(m_hParent); }	// Vater Objekt
	virtual CHandle<ISceneGraphObject>	GetNext				( void )					{ return(m_hNext); }	// nachfolgende Objekte
	virtual CHandle<ISceneGraphObject>	GetIn				( void )					{ return(m_hIn); }		// enthaltene Objekte
	virtual void						SetParent			( ISceneGraphObject *p )	{ m_hParent=p; }		// Vater Objekt
	virtual void						SetNext				( ISceneGraphObject *p )	{ m_hNext=p; }			// nachfolgende Objekte
	virtual void						SetIn				( ISceneGraphObject *p )	{ m_hIn=p; }			// enthaltene Objekte
	virtual void						ReleaseSubObjects	( void );											// Unterobjekte freigeben
	virtual bool						InsertObject		( ISceneGraphObject *p );							// Unterobjekt einfgen
	virtual void						ReleaseObject		( void );											// Austragen
	virtual void						OnChildReleased		( ISceneGraphObject *p );							// 
	virtual bool						InsertObjectAtEnd	( ISceneGraphObject *p );		// Unterobjekt einfgen, hinten O(n), n=Anz. Elemente in der Liste

	// Interface ISerialize
	virtual void						Serialize			( CSerializeArchivePointer &ar );
	virtual void						SerializeRecursive	( CSerializeArchivePointer &ar );
	virtual	void						OnAfterLoad			( void );
	
	
	/////////////////////////////////////////////////////////////////////////////
	// Membervariablen
	//

protected:
	CHandle<ISceneGraphObject>	m_hIn;		// enthaltene Objekte
	CHandle<ISceneGraphObject>	m_hNext;	// nachfolgende Objekte (einfach verkettet)
	CHandle<ISceneGraphObject>	m_hParent;	// VaterObjekt, Redundant, wird nicht serialisiert

protected:
	CRect2I						m_rect;
//	IUnknown *					m_pUnknownInner;		// fr Aggregation
};







#endif // !defined(AFX_DOCOBJECT_H__F994F94D_CD3F_11D3_BD1F_0000B465D2C5__INCLUDED_)
