#ifndef _WINGUI_H
#define _WINGUI_H

#include <objbase.h>

#ifdef INITGUID
#include <initguid.h>
#endif

class IGUIDialogCallback;
class CGUIDlgData;
class IWinGUIButton;
class CRect2I;
class CPoint2I;

typedef CHandle<ISceneGraphObject>	GHnd;
typedef ISceneGraphObject *			GPtr;



// unfinished
enum CRGUI_AlignMode
{
	alignl_min=0,			// *** ******* **** *                  //

	alignl_max=1,			//				    *** ******* **** * //
	
	alignl_center=2,		//		   *** ******* **** *		   //	
	
	alignl_stretch=3,		// ******* ************** ******** *** //	default

//	alignl_equal=4,			// ******** ******** ******** ******** //

//	alignl_block=5			// ***       *******       ****      * //
};

// Flags
#define CWINGUI_FGRAYED			1



enum CRGUI_BorderMode
{
	borderm_none=0,			//
	borderm_edgedframe=1	//	default
//	borderm_sunken=2,		//
};



enum CRGUI_Command			// bergebene Paramater				Commando
{
	cmd_ValueChanged=0,		// Caller_UserId,Caller_Ptr,?Item	Attributenderung
	cmd_Trigger=1,			// Caller_UserId,Caller_Ptr			Button Pressed
	cmd_GetFocus=2,			// Caller_UserId,Caller_Ptr			Maus rauf, Hover
	cmd_LostFocus=3,		// Caller_UserId,Caller_Ptr			Maus runter, Hover
	cmd_DialogMessage=4,	// String_Ptr						Debugging
	cmd_Open=5,				// Caller_UserId,Caller_Ptr			Tree Item expand
	cmd_Close=6				// Caller_UserId,Caller_Ptr,Item	Tree Item contract
};


// Sollte sich das Paket noch erweitern, sollte die MessageVersion erhhen und die Struktur nach unten
// hin vergrern. Kann man alle Applikationen umstellen(meist nur neukompilieren), ist das nicht ntig
//
// MessageVersion=0
struct CRGUI_ControlMessage
{
	int					MessageVersion;
	enum CRGUI_Command	Cmd;

	IWinGUIButton		*Caller_Ptr;
	ULONG				Caller_UserId;
	char				*String_Ptr;		// frs Debugging
	ULONG				Item;				// z.B. fr Tree oder List Item Identifinzierung
//	IWinGUIDialog		*Dialog_Ptr;
};
















// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************




// Bemerkung:
// 
// * um selbst erzeugte Buttons einzufgen
//   ISceneGraphObject::InsertObjectAtEnd(ISceneGraphObject *p) verwenden
//
class IWinGUI : public IUnknown
{
public:
 virtual bool	__stdcall	Create					( void )=0;
 virtual void	__stdcall	GetAppParentData		( CGUIAppData &dat )=0;

 // um Fenster zu generieren
 virtual GHnd	__stdcall	CreateWindow_Dialog		( ULONG dwUserId, IGUIDialogCallback *c, 
															const char *Name, bool HGroup, 
															enum CRGUI_AlignMode x,
															enum CRGUI_AlignMode y )=0;

 // um ein Directory auswhlen zu knnen
  virtual GHnd	__stdcall	CreateWindow_DialogChooseDir( ULONG dwUserId, IGUIDialogCallback *c, 
															const char *Name )=0;

 // Popupmens, Menleisten fr MDI und SDI Childs (in Fenster oder wieder in Mens einfgen
 //													oder allein als Popupmen)
 virtual GHnd	__stdcall	CreateWindow_MenuBar	( ULONG dwUserId, GPtr InTo, const char *Name )=0;

 // um Standbuttons zu generieren und einzufgen
 virtual GHnd	__stdcall	InsertButton_Push		( ULONG UserId, GPtr InTo, const char *Name, ULONG Flags=0 )=0;
 virtual GHnd	__stdcall	InsertButton_Check		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_Radio		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_Combo		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_Edit		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_List		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_Group		( GPtr InTo, const char *Name, bool HGroup, 
															enum CRGUI_AlignMode x,
															enum CRGUI_AlignMode y,
															enum CRGUI_BorderMode b	)=0;
 virtual GHnd	__stdcall	InsertButton_GroupTab	( ULONG UserId, GPtr InTo )=0;
 virtual GHnd	__stdcall	InsertButton_Static		( ULONG UserId, GPtr InTo, const char *Text )=0;
 virtual GHnd	__stdcall	InsertButton_Tree		( ULONG UserId, GPtr InTo, const char *Name )=0;
 virtual GHnd	__stdcall	InsertButton_Canvas		( ULONG UserId, GPtr InTo, DWORD inWidth, DWORD inHeight,
													  LPDIRECTDRAW7 lpDD, CHandle<I2DMemoryDC> &outMDC )=0;
};
// {0D199A21-874D-4a04-AF0C-DB583ECBA70A}
DEFINE_GUID(IID_IWinGUI, 0xd199a21, 0x874d, 0x4a04, 0xaf, 0xc, 0xdb, 0x58, 0x3e, 0xcb, 0xa7, 0xa);



// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************



class IWinGUIDialog : public IUnknown
{
public:
 virtual bool					__stdcall ReleaseWindow		( void )=0;
 virtual IGUIDialogCallback *	__stdcall GetDialogCallback	( void )=0;
 virtual IWinGUIButton *		__stdcall GetPtrFromUserId	( ULONG id )=0;	// rekursiv alle Unterelemente

 // interne Verwendung
 virtual IWinGUIButton *		__stdcall GetPtrFromWinId	( ULONG id )=0;	// nicht sehr effizient, wenn ntig, knnte man hier ber eine Tabelle arbeiten
};
// {71AF2484-EB39-4d1c-BCF6-04976D6776B6}
DEFINE_GUID(IID_IWinGUIDialog, 0x71af2484, 0xeb39, 0x4d1c, 0xbc, 0xf6, 0x4, 0x97, 0x6d, 0x67, 0x76, 0xb6);



// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************




 // interne Verwendung
class IWinGUIMenuBar : public IUnknown
{
public:
 // interne Verwendung
 virtual ULONG					__stdcall GetMenuHnd( void )=0;
};
// {5599FD90-7EDA-45c4-902D-BE9E4CFB9F6C}
DEFINE_GUID(IID_IWinGUIMenuBar, 0x5599fd90, 0x7eda, 0x45c4, 0x90, 0x2d, 0xbe, 0x9e, 0x4c, 0xfb, 0x9f, 0x6c);



// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************


// nur fr den internen Gebrauch, Windows Implementierung
class IWinGUIButton : public IUnknown
{
public:
 virtual void					__stdcall GetDlgParentData	( CGUIDlgData &dat )=0;
	
 virtual bool					__stdcall SetValue			( ULONG val )=0;	// fr Radio oder Checkbox
 virtual bool					__stdcall GetValue			( ULONG &val )=0;	// fr Radio oder Checkbox
 virtual bool					__stdcall SetText			( char *txt )=0;
 virtual bool					__stdcall GetText			( char *buf, ULONG bufsize )=0;
 virtual bool					__stdcall PushItem			( char *intxt, ULONG inuser, ULONG inparent, ULONG *outuser=0 )=0;
 virtual bool					__stdcall RemoveAllItems	( void )=0;

 virtual IWinGUIDialog *		__stdcall GetDialogPtr		( void )=0;
 virtual ULONG					__stdcall GetUserId			( void )=0;
 virtual void					__stdcall SetHideFlag		( bool f )=0;

 // interne Verwendung
 virtual LRESULT				__stdcall WndProc			( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, IGUIDialogCallback *b )=0;
 virtual ULONG					__stdcall _GetWinId			( void )=0;
 virtual IWinGUIButton *		__stdcall _GetPtrFromUserId	( ULONG id )=0;	// rekursiv alle Unterelemente
};
// {8B8555B8-20EA-47a7-9E9E-40342DCE0A8F}
DEFINE_GUID(IID_IWinGUIButton, 0x8b8555b8, 0x20ea, 0x47a7, 0x9e, 0x9e, 0x40, 0x34, 0x2d, 0xce, 0xa, 0x8f);



// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************

// Interface IButtonTreeItem
class IWinGUIButtonTreeItem : public IUnknown
{
public:
 virtual bool					__stdcall GetItemFirstChild	( ULONG inItem, ULONG &out )=0;
 virtual bool					__stdcall GetItemNext		( ULONG inItem, ULONG &out )=0;
 virtual bool					__stdcall GetItemParent		( ULONG inItem, ULONG &out )=0;
 virtual bool					__stdcall GetItemData		( ULONG inItem, ULONG &outUser, 
															  char outName[255], bool &outOpen )=0;
 virtual bool					__stdcall SetItemData		( ULONG inItem, ULONG inUser, 
															  char *inName, bool inOpen )=0;
 virtual bool					__stdcall DeleteItem		( ULONG inItem )=0;

 virtual bool					__stdcall GetItemCursor		( ULONG &outItem )=0;
 virtual bool					__stdcall SetItemCursor		( ULONG inItem )=0;
};
// {EB7A63FD-1339-461d-A701-F412D9C7CD86}
DEFINE_GUID(IID_IWinGUIButtonTreeItem, 0xeb7a63fd, 0x1339, 0x461d, 0xa7, 0x1, 0xf4, 0x12, 0xd9, 0xc7, 0xcd, 0x86);



// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************


class I2DAutoLayout : public IUnknown
{
public:
 virtual bool					__stdcall CreateLayoutRecursive	( ULONG &id )=0;			// Buttons generieren, RecalcLayoutRecursive vorher aufrufen
 virtual void					__stdcall RecalcLayoutRecursive	( void )=0;					// Button Abmessungen/Pos erneut berechnen
 virtual void 					__stdcall ReleaseLayoutRecursive( void )=0;					// Buttons freigeben
 virtual void 					__stdcall SetOuterBorder		( const CRect2I rect )=0;	// Rndergren festlegen
 virtual void 					__stdcall GetOuterBorder		( CRect2I &rect )=0;		// Rndergren auslesen
 virtual void 					__stdcall SetHVSpacing			( const CPoint2I p )=0;		// Innenelemente Abstnde festlegen, fr Gruppierungen
 virtual void 					__stdcall GetHVSpacing			( CPoint2I &p )=0;			// Innenelemente Abstnde auslesen, fr Gruppierungen

 // die nchsten 3 Methoden werden nur von RecalcLayoutRecursive benutzt
 virtual void 					__stdcall _CalcDimensionsRecursive( ULONG &w, ULONG &h )=0;	// Gre rekursiv ermitteln
 virtual void 					__stdcall _GetDimension			( ULONG &w, ULONG &h, 
																  bool &fixx, bool &fixy )=0;	// wird nach Dim. und vor Spac. aufgerufen
 virtual void 					__stdcall _CalcSpacingRecursive	( CPoint2I offs, ULONG w, ULONG h )=0;	// Position korrigieren
};
// {5EB76990-8497-4905-8E1D-C5C9A1AF39B0}
DEFINE_GUID(IID_I2DAutoLayout, 0x5eb76990, 0x8497, 0x4905, 0x8e, 0x1d, 0xc5, 0xc9, 0xa1, 0xaf, 0x39, 0xb0);








// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************
// ********************************************************************************************************

class IGUIDialogCallback : public IUnknown
{
public:
 virtual void					__stdcall OnControlMessage		( CRGUI_ControlMessage &m )=0;
};
// {54E72D05-2C04-42f4-8869-12FA97AE9364}
DEFINE_GUID(IID_IGUIDialogCallback, 0x54e72d05, 0x2c04, 0x42f4, 0x88, 0x69, 0x12, 0xfa, 0x97, 0xae, 0x93, 0x64);




#endif