// CComponentBase.cpp: implementation of the CComponentBase class.
//
//////////////////////////////////////////////////////////////////////

//#ifdef _AFXDLL				// MFC
//  #include "stdafx.h"
//#endif

#include <assert.h>
#include "CComponentBase.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

long CComponentBase::m_cActiveComponents	= 0;

CComponentBase::CComponentBase() : m_RefCount(1)
{
//	if(!pUnknownOuter)
//	{
//		m_pUnknownOuter	= reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this));
//	}
//	else
//	{
//		m_pUnknownOuter	= pUnknownOuter;
//	}

	::InterlockedIncrement(&m_cActiveComponents);
}

CComponentBase::~CComponentBase()
{
	::InterlockedDecrement(&m_cActiveComponents);
}

/*
void CComponentBase::CleanUp()
{
	m_RefCount	= 1;
}
*/



HRESULT __stdcall CComponentBase::QueryInterface_ND(const IID &iid,LPVOID *ppv)
{	
	if(iid == IID_IUnknown)
	{
		return	FinishQI(reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)),ppv);
	}
	else
	{
		*ppv	= 0L;
		return	E_NOINTERFACE;
	}
}

ULONG __stdcall CComponentBase::AddRef_ND()
{
	return ::InterlockedIncrement(&m_RefCount);
}

ULONG __stdcall CComponentBase::Release_ND()
{
	::InterlockedDecrement(&m_RefCount);

	assert(m_RefCount>=0);
	if(!m_RefCount)
	{
//		CleanUp();

		delete this;
		return 0;
	}

	return m_RefCount;
}

// Finish QueryInterface
HRESULT CComponentBase::FinishQI(IUnknown *pUnknown,LPVOID *ppv)
{
	*ppv	= pUnknown;
	pUnknown->AddRef();

	return S_OK;
}
