// CComponentBase.h: interface for the CComponentBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CCOMPONENTBASE_H__566F6407_E111_11D2_A179_444553540000__INCLUDED_)
#define AFX_CCOMPONENTBASE_H__566F6407_E111_11D2_A179_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

#include <objbase.h>
#include <assert.h>

interface IUnknown_ND
{
	virtual	HRESULT	__stdcall	QueryInterface_ND(const IID &iid,LPVOID *ppv)	= 0;
	virtual	ULONG	__stdcall	AddRef_ND()										= 0;
	virtual ULONG	__stdcall	Release_ND()									= 0;
};




class CComponentBase : public IUnknown_ND, public IUnknown
{
public:
								CComponentBase		( void );
	virtual ~					CComponentBase		( void );


	// IUnknown_ND implementation

	virtual	HRESULT	__stdcall	QueryInterface_ND	( const IID &iid,LPVOID *ppv );
	virtual	ULONG	__stdcall	AddRef_ND			( void );
	virtual ULONG	__stdcall	Release_ND			( void );
	

	// Initialization & CleanUp

	virtual	HRESULT				Init				( void )			{	return S_OK;	}
//	virtual void				CleanUp				( void );


	// Helper Functions

	HRESULT						FinishQI			( IUnknown *pUnknown,LPVOID *ppv );
	static long					GetActiveComponents	( void )			{	return m_cActiveComponents;	}
	
	// hauptschlich fr Reference Guard
	long						GetRefCount			( void )			{ return(m_RefCount); }

protected:
//	IUnknown *					GetOuterComponent	( void ) const		{	return m_pUnknownOuter;		}





private:
	long		 m_RefCount;				// Reference Counter

	static long	 m_cActiveComponents;		// um feststellen zu knnen, ob sich die Komponente entladen darf
};

/*
#define DECLARE_IUNKNOWN															\
		virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)		\
				{	return GetOuterComponent()->QueryInterface(iid,ppv);	}		\
		virtual ULONG	__stdcall AddRef()											\
				{	return GetOuterComponent()->AddRef();					}		\
		virtual ULONG	__stdcall Release()											\
				{	return GetOuterComponent()->Release();					}



#ifdef _DEBUG
	#define DECLARE_IUNKNOWN_ReferenceControlled(ComponentName)								\
	virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)					\
			{	return GetOuterComponent()->QueryInterface(iid,ppv);	}					\
	virtual ULONG	__stdcall AddRef()														\
			{	ULONG ref=GetOuterComponent()->AddRef();									\
				if(ref==2)if(g_App->GetReferenceGuard())g_App->GetReferenceGuard()->AddControlledItem(#ComponentName,static_cast<IUnknown_ND *>(static_cast<CComponentBase*>(this)));	\
				return(ref);																\
			}																				\
	virtual ULONG	__stdcall Release()														\
			{	if(GetRefCount()==1)if(g_App->GetReferenceGuard())g_App->GetReferenceGuard()->SubControlledItem(static_cast<IUnknown_ND *>(static_cast<CComponentBase*>(this)));		\
				return GetOuterComponent()->Release();					}
#else
	#define DECLARE_IUNKNOWN_ReferenceControlled(ComponentName)										\
	virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)		\
			{	return GetOuterComponent()->QueryInterface(iid,ppv);	}		\
	virtual ULONG	__stdcall AddRef()											\
			{	return GetOuterComponent()->AddRef();					}		\
	virtual ULONG	__stdcall Release()											\
			{	return GetOuterComponent()->Release();					}	
#endif
*/



#define DECLARE_IUNKNOWN															\
		virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)		\
				{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->QueryInterface(iid,ppv);	}		\
		virtual ULONG	__stdcall AddRef()											\
				{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->AddRef();					}		\
		virtual ULONG	__stdcall Release()											\
				{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->Release();					}



#ifdef _DEBUG
	#define DECLARE_IUNKNOWN_ReferenceControlled(ComponentName)								\
	virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)					\
			{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->QueryInterface(iid,ppv);	}					\
	virtual ULONG	__stdcall AddRef()														\
			{	ULONG ref=(reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->AddRef();									\
				if(ref==2)if(g_App->GetReferenceGuard())g_App->GetReferenceGuard()->AddControlledItem(#ComponentName,static_cast<IUnknown_ND *>(static_cast<CComponentBase*>(this)));	\
				return(ref);																\
			}																				\
	virtual ULONG	__stdcall Release()														\
			{	if(GetRefCount()==1)if(g_App->GetReferenceGuard())g_App->GetReferenceGuard()->SubControlledItem(static_cast<IUnknown_ND *>(static_cast<CComponentBase*>(this)));		\
				return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->Release();					}
#else
	#define DECLARE_IUNKNOWN_ReferenceControlled(ComponentName)										\
	virtual HRESULT __stdcall QueryInterface(const IID &iid,LPVOID *ppv)		\
			{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->QueryInterface(iid,ppv);	}		\
	virtual ULONG	__stdcall AddRef()											\
			{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->AddRef();					}		\
	virtual ULONG	__stdcall Release()											\
			{	return (reinterpret_cast<IUnknown*>(static_cast<IUnknown_ND*>(this)))->Release();					}	
#endif


#define BEGIN_INTERFACES				virtual HRESULT __stdcall QueryInterface_ND(const IID& iid, void** ppv) { 	
#define INTERFACE_ENTRY(Interface)		if(iid == (IID_##Interface)) { return FinishQI(static_cast<Interface*>(this),ppv); } 
#define END_INTERFACES					return CComponentBase::QueryInterface_ND(iid,ppv); }

#define STATIC_CREATE_COMPONENT(ClassObj)																	\
		static	HRESULT	CreateComponent(IUnknown *pUnknownOuter,CComponentBase **ppNewComponent)			\
		{																									\
			*ppNewComponent = new ClassObj() ;													\
			return S_OK ;																					\
		}																									\

/*
#define STATIC_CREATE_COMPONENT(ClassObj)																	\
		static	HRESULT	CreateComponent(IUnknown *pUnknownOuter,CComponentBase **ppNewComponent)			\
		{																									\
			if(pUnknownOuter)																				\
				return CLASS_E_NOAGGREGATION ;																\
			*ppNewComponent = new ClassObj(pUnknownOuter) ;													\
			return S_OK ;																					\
		}																									\
*/
#endif
