// CInstanceFactory.h: interface for the CInstanceFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CINSTANCEFACTORY_H__95DCC62A_ED59_48A6_A6CD_F2EBBD9A68C7__INCLUDED_)
#define AFX_CINSTANCEFACTORY_H__95DCC62A_ED59_48A6_A6CD_F2EBBD9A68C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include "CClassFactoryBase.h"
//#include "Interfaces.h"

#include <vector>
using namespace std;

typedef CClassFactoryData * (*GETCLASSFACTORIES)(int &iCount);
typedef HRESULT (*CREATEINSTANCE)(const CLSID &cid,LPVOID *pUnknown);
typedef bool (*INITDLL)(IUnknown *p);

struct InstanceInfo				// ex. fr jede DLL
{
	CClassFactoryData	*iiData;	// Zeiger auf das Array mit den COM-Object Daten
	int					 iiCount;	// Anzahl der COM-Objekt in der DLL
	CREATEINSTANCE		CreateFunc;
};

class CInstanceFactory  
{
public:
	class iterator
	{
		public:
			iterator()
			{
				m_iDLLEntry=0;m_pFacEntry=0;m_pFactory=0;
			}
			iterator( CInstanceFactory &p )
			{
				m_pFactory=&p;
				if(!p.m_lstInstanceInfos.empty())
				{
					m_iDLLEntry=p.m_lstInstanceInfos.begin();
					m_pFacEntry=(*m_iDLLEntry).iiData;
				}
				else
				{
					m_iDLLEntry=0;m_pFacEntry=0;m_pFactory=0;
				}
			}

		// Copy Konstruktor
		iterator( iterator &r )
		{	
			m_iDLLEntry=r.m_iDLLEntry;m_pFacEntry=r.m_pFacEntry;m_pFactory=r.m_pFactory;
		}

		CClassFactoryData & operator *()
		{
			return(*m_pFacEntry);
		}
		InstanceInfo *GetFactoryEntry( void )
		{
			return &(*m_iDLLEntry);
		}
		void operator=( iterator &r )
		{
			m_iDLLEntry=r.m_iDLLEntry;m_pFacEntry=r.m_pFacEntry;m_pFactory=r.m_pFactory;
		}
		bool operator==( iterator &r )
		{
			return(m_pFacEntry==r.m_pFacEntry);
		}
		bool operator!=( iterator &r )
		{
			return(!(operator==(r)));
		}
		iterator & operator++( int )
		{
			if(m_pFacEntry)	// noch nicht am Ende
			{
				m_pFacEntry++;
				if(m_pFacEntry->m_pCLSID==0L)	// Endmarker
				{
					m_iDLLEntry++;
					if(m_iDLLEntry==m_pFactory->m_lstInstanceInfos.end())m_pFacEntry=0;	// Ende
						else m_pFacEntry=(*m_iDLLEntry).iiData;
				}
			}

			return(*this);
		}
		bool HasInterface( IID iid/*InterfaceId id */)
		{
#pragma message("Hasinterface todo")
//				IUnknown *p = CreateInstance(*m_pFacEntry->m_pIID);
			//return( (m_pFacEntry->interfaces(id,(void *)0xffffffff))!=0 );
			return false;
		}
		iterator operator++( void )
		{
			iterator clone=*this;

			(*this)++;
			return(clone);
		}

		private:
			CInstanceFactory *					m_pFactory;		// Factory auf der der Iterator luft (es gibt nur eine Factory)
			vector<InstanceInfo>::iterator		m_iDLLEntry;	// Zeiger auf DLL
			CClassFactoryData *					m_pFacEntry;	// Zeiger auf den aktuellen Eintrag
	};

	friend class iterator;

	// fr Iterator
	iterator begin( void )
	{
		return(iterator(*this));
	}
	iterator end( void )
	{
		return(iterator());
	}

private:
	vector<InstanceInfo>	m_lstInstanceInfos;

public:
	CInstanceFactory();
	virtual ~CInstanceFactory();

	bool			Init					( char *pPathName, IUnknown *app );
	IUnknown *		CreateInstance			( const CLSID iid );
	IUnknown *		CreateInstance			( const char *pName );
};

#endif
