// DLL Main for COM - Objects

//#ifdef _AFXDLL				// MFC
//  #include "stdafx.h"
//#endif

#include <windows.h>

#include "CClassFactoryBase.h"
#include "CComponentBase.h"

STDAPI DllCanUnloadNow()													{	return CClassFactoryBase::CanUnloadNow();					}
STDAPI DllGetClassObject(const CLSID &clsID,const IID &iid,LPVOID *ppv)		{	return CClassFactoryBase::GetClassObject(clsID,iid,ppv);	}
STDAPI DllRegisterServer()													{	return CClassFactoryBase::Register();						}
STDAPI DllUnregisterServer()												{	return CClassFactoryBase::UnRegister();						}

extern CClassFactoryData	g_ClassFactoryData[];


BOOL APIENTRY DllMain(HANDLE hModule,DWORD dwReason,LPVOID lpReserved)
{
    switch(dwReason)
	{
	    case DLL_PROCESS_ATTACH:			CClassFactoryBase::m_hModule	= (HINSTANCE) hModule;
											break;
	    case DLL_THREAD_ATTACH:
	    case DLL_THREAD_DETACH:
	    case DLL_PROCESS_DETACH:
		default:							break;
    }

    return TRUE;
}

// m.m. entwas umgeschrieben, nun wird count jedesmal neu ermittelt, mu dafr aber nicht
// mehr in der Komponente initialisiert werden.
extern "C" __declspec(dllexport) CClassFactoryData * GetClassFactories(int &iCount)
{
	iCount=0;

	for(int i = 0;; i++)
	{
		const CClassFactoryData	*pData	= &g_ClassFactoryData[i];

		if(pData->m_pCLSID==0)break;		// Endemarker

		iCount++;
	}

	return g_ClassFactoryData;
}


// diese Methode wird nur fr COM-Kompatibilitt benutzt ??????
extern "C" __declspec(dllexport) HRESULT CreateInstance(const CLSID &cid,LPVOID *pUnknown)
{
	for(int i = 0;; i++)
	{
		const CClassFactoryData	*pData	= &g_ClassFactoryData[i];

		if(pData->m_pCLSID==0)break;		// Endemarker

		if(*pData->m_pCLSID==cid)
		{
			CComponentBase	*pNewComponent;			// Create the component

			HRESULT	hr	= pData->CreateComponent(0L,&pNewComponent);	

			if(FAILED(hr))
				return hr;

			// refcount=1

			hr	= pNewComponent->Init();			// Initialize the component

			if(FAILED(hr))
			{
				pNewComponent->Release_ND();
				return hr;
			}

			hr	= pNewComponent->QueryInterface_ND(IID_IUnknown,pUnknown);

			// refcount=2
			
			pNewComponent->Release_ND();

			// refcount=1

			return hr;
		}
	}

	return E_FAIL;
}


