// ASCIIFile.h: Schnittstelle fr die Klasse CASCIIFile.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ASCIIFILE_H__6D4E92CB_AC6C_4ED7_BE1C_FFF26A95937C__INCLUDED_)
#define AFX_ASCIIFILE_H__6D4E92CB_AC6C_4ED7_BE1C_FFF26A95937C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// 0 Byte terminierte char ASCII Datei
// fr FILE-IO

#define ULONG unsigned long
 
class CASCIIFile  
{
public:
					CASCIIFile			();								// Konstruktor
	virtual			~CASCIIFile			();								// Destruktor
					CASCIIFile			( CASCIIFile &a );				// Copy Konstruktor

   const CASCIIFile operator=			( const CASCIIFile &a );		// Zuweisungsoperator

	void			CoverThisData		( char *ptr, ULONG size );		// altes freigeben, neues bernehmen, keine Kopie machen,
																		// size ist ohne Nullterm., Data soll nullterminiert sein
	ULONG			GetDataSize			( void );						// Gre ohne Nullbyte
	char *			GetDataPtr			( void );						// Speicherposition

	void			ReleaseData			( void );						// Daten freigeben und Size zurcksetzen

	static bool		IO_GetAvailability	( const char *pathname );		// Hilfsfkt, ob Datei vorhanden ist
	static ULONG	IO_GetFileSize		( const char *pathname );		// Hilfsfkt, ob wie gro Datei ist

	bool			IO_SaveASCIIFile	( const char *pathname );		// Speichern
	bool			IO_LoadASCIIFile	( const char *pathname );		// Laden

	// INI File Hilfsfunktionen, knne man auch erst in einer Ableitung zur Verfgung stellen
	bool			FindStartINIGroup	( const char *ingrpname, ULONG &outGrpStart, ULONG &outGrpEnd );

	bool			GetINIString		( ULONG inGrpStart, ULONG inGrpEnd, 
										  const char *inname, char *outString,
										  ULONG inMaxChar, ULONG *outGetPos=0 );

protected:
	char		*m_Data;				// Zeiger auf malloc Speicher
	ULONG		m_Size;					// einschlielich terminierendes 0Byte (sonst 0)
};

#endif // !defined(AFX_ASCIIFILE_H__6D4E92CB_AC6C_4ED7_BE1C_FFF26A95937C__INCLUDED_)
