// CRApplication.cpp: Implementierung der Klasse CCRApplication.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"

#include "CRApplication.h"
#include "..\..\shared\CInstanceFactory.h"							// CInstanceFactory
#include <time.h>													// time

extern IEditorApplication *g_App;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CCRApplication::CCRApplication()
{

}

CCRApplication::~CCRApplication()
{

}




bool CCRApplication::CRApplicationInit( void )
{
	g_App=(IEditorApplication *)(this);


	assert(_g_Factory);												// _g_Factory wurde nicht initialisiert
	if(!_g_Factory->Init("Plugins",(IEditorApplication *)this))
	{
		MessageBox(0,"Plugins init failed","Error",MB_OK);	
		return(false);
	}


	// Message-,Error-Handler Start
	{
		if(IUnknown *p=p=_g_Factory->CreateInstance("MIT.MessageHandler"))
		{
			// refcount=1
			m_error=QUERYINTERFACE(IMessageHandler,p);
			// refcount=2
			if(m_error)m_error->Create(25,1);			// 25 Stck puffern
			p->Release();
			// refcount=1
		}

	}
	{
		if(IUnknown *p=_g_Factory->CreateInstance("MIT.MessageHandler"))
		{
			m_message=QUERYINTERFACE(IMessageHandler,p);
			if(m_message)
			{ 
				m_message->Create(2000,2);				// 2000 Stck puffern

				struct tm *newtime;

				time_t aclock;
				time( &aclock );						// Get time in seconds 

				newtime = localtime( &aclock );

				m_message->Add("last compiletime: %s",__DATE__);

				char datstr[30];

				strcpy(datstr,asctime( newtime ));		// liefert: "Wed Jan 02 02:03:55 1980\n\0"
				datstr[24]=0;							// um \n wegzumachen

				m_message->Add("actual date and time: %s",datstr);
			}
			p->Release();
		}
	}
	// Message-,Error-Handler Ende




	
	// WinGUI Start
	{
		if(IUnknown *p=_g_Factory->CreateInstance("MIT.WinGUI"))
		{
			m_gui=QUERYINTERFACE(IWinGUI,p);
			p->Release();
		}
		else
		{
			MessageBox(0,"GUI Plugin not found","Error",MB_OK);			
			return(false);
		}

		assert(m_gui);
		m_gui->Create();											// Init
		// WinGUI Ende
	}

	return(true);
}