// CRApplication.h: Schnittstelle fr die Klasse CCRApplication.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CRApplication_H__408BCB51_2FD5_4DF5_B992_4E5EB5202108__INCLUDED_)
#define AFX_CRApplication_H__408BCB51_2FD5_4DF5_B992_4E5EB5202108__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\..\shared\CComponentBase.h"							// CComponentBase, IUnknown_ND
#include "..\..\shared\interfaces.h"								// IEditorApplication
#include "..\..\PlugInSource\MessageHandler\IMessageHandler.h"		// IMessageHandler
#include "..\..\PlugInSource\WinGUI\IWinGUI.h"						// IGUIDialogCallback
#include "..\..\PlugInSource\ReferenceGuard\IReferenceGuard.h"		// IReferenceGuard

extern CInstanceFactory *_g_Factory;								// in Component.cpp definiert





class CCRApplication  : public IEditorApplication
{
public:
	CCRApplication();
	virtual ~CCRApplication();

	// Interface IEditorApplication
	virtual DWORD				GetVersion			( void ) { return(0); }
	virtual IMessageHandler *	GetErrorHandler		( void ) { return(m_error); }
	virtual IMessageHandler *	GetMessageHandler	( void ) { return(m_message); }
	virtual IReferenceGuard *	GetReferenceGuard	( void ) { return(m_RefGuard); }
	virtual IWinGUI *			GetWinGUI			( void ) { return(m_gui); }
	virtual CInstanceFactory *	GetFactory			( void ) { return(_g_Factory); }
	virtual IPopUpMenu *		GetPopupHandler		( void ) { return(0); }

// zum berladen	

//	virtual bool				GetGUIAppData		( CGUIAppData &ret );		// damit man der Applikation Dialoge/Toolbar/... anhngen kann
//	virtual void				OnCallCommand		( WPARAM wParam ){}

protected:

	CHandle<IMessageHandler>	m_error;			// Fehleraufzeichnung (error.txt - wird nach Programmende angezeigt)
	CHandle<IMessageHandler>	m_message;			// Nachrichtenaufzeichnung (message.txt)
	CHandle<IWinGUI>			m_gui;				// Userinterface
	CHandle<IReferenceGuard>	m_RefGuard;			// RefereceGuard, Tool zum berwachen der Objektfreigabe

	bool						CRApplicationInit	( void );
};






#endif // !defined(AFX_CRApplication_H__408BCB51_2FD5_4DF5_B992_4E5EB5202108__INCLUDED_)
