#ifndef _I2DGUIOBJECT_H
#define _I2DGUIOBJECT_H



class I2DGUIObject : public IUnknown 
{ 
public:
	// Interface Methods

	// Draw
	virtual void			Draw				( I2DMemoryDC *pMC, CPoint2I pos, int inMagnify )=0;
	virtual void			MarkedDraw			( I2DMemoryDC *pMC, int r, CPoint2I pos, int inMagnify )=0;	//wird zusttzlich zu Draw aufgerufen, wenn Objekt markiert ist

	// Interaktion mit einer Menge von Objekten (1..n)
	// z.B. ein 3D Objekt, eine Lichtquelle, eine Kamera, ein Texture-UV Modifier
	// oder z.B. die Subobjekte eines 3D Objektes (Punkte, Kanten oder Dreiecke )




//	virtual void			MoveObject			( CPoint2I rel, ULONG &AnchorPoint )=0;
//	virtual void			ScaleObject			( CPoint2I rel )=0;
//	virtual ULONG			IsAnchorPointAt		( int r, CPoint2I xy )=0;	// nur fr markierte Objekte, 0, wenn dort kein Punkt, sonst ist dort ein Angriffspunkt (Skalieren, ...)
//	virtual bool			IsObjectAt			( CPoint2I xy )=0;
//	virtual	CRect2I			GetRect				( void )=0;
//	virtual	void			SetRect				( const CRect2I &r )=0;
//	virtual I2DDraw *		GetTopObjectAt		( CPoint2I xy )=0;			// arbeitet auch rekursiv
//	virtual I2DDraw *		GetTopAnchorPointAt ( int r, CPoint2I xy, ULONG &anchorid )=0;	// arbeitet rekursiv, id von 1 bis ...
//	virtual	void			OnContextMenu		( IPopUpMenu *p, CPoint2I xy )=0;
//	virtual	CPoint2I		GetWorldPosition	( void )=0;					// arbeitet rekursiv
};

// {98D9C642-15D9-4792-A505-E53B684B84EB}
DEFINE_GUID(IID_I2DGUIObject, 0x98d9c642, 0x15d9, 0x4792, 0xa5, 0x5, 0xe5, 0x3b, 0x68, 0x4b, 0x84, 0xeb);




#endif	// _I2DGUIOBJECT_H
