// TLMemPool.h:
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TMEMPOOL1_H__BEA5D80A_F01C_4058_8831_D2897C6031BA__INCLUDED_)
#define AFX_TMEMPOOL1_H__BEA5D80A_F01C_4058_8831_D2897C6031BA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// very efficient
// low memory consumption ( mem_needed = max(4*Size,sizeof(T)*Size)+4 )

template <class T>
class CTMemPool
{
public:

	union T2
	{
//		T		m_Data;
		char	m_Data[sizeof(T)];
		T2 *	m_Next;
	};

	// *********************************************************************************
				CTMemPool	( unsigned long inSize )
	{
		m_Elements=new T2[inSize];

		m_FreeList=m_Elements;				// start of FreeList elements

		T2 *p1=m_Elements,*p2=p1+1;

		for(unsigned long i=0;i<inSize-1;i++)
			(p1++)->m_Next=p2++;	// chain of FreeList elements

		p1->m_Next=0;						// last element
	}

	// *********************************************************************************
				~CTMemPool	()
	{
		delete m_Elements;
	}

	// *********************************************************************************
	T *			New			( void )
	{
		T2 *ret=m_FreeList;

		if(!ret)return(0);		// full

		m_FreeList=ret->m_Next;

		
		T *ret2=(T *)&(ret->m_Data);

		*ret2=T();							// call default constructor (& assignment operator)

		return(ret2);
	}

	// *********************************************************************************
	T *			New			( const T &in )
	{
		T2 *ret=m_FreeList;

		if(!ret)return(0);		// full

		m_FreeList=ret->m_Next;

		T *ret2=(T *)&(ret->m_Data);

		*ret2=in;
		return(ret2);
	}

	// *********************************************************************************
	void		Delete		( T *el )
	{
		((T2 *)el)->m_Next=m_FreeList;

		m_FreeList=((T2 *)el);
	}
	// *********************************************************************************
	// *********************************************************************************
	// *********************************************************************************

	T2			*m_Elements;
	T2 *		m_FreeList;
};





#endif // !defined(AFX_TMEMPOOL1_H__BEA5D80A_F01C_4058_8831_D2897C6031BA__INCLUDED_)
