// GuidTypDef.cpp: implementation of the CGuidTypDef class.
//
//////////////////////////////////////////////////////////////////////

//#ifdef _AFXDLL				// MFC
//  #include "stdafx.h"
//#endif

#include <assert.h>

#include <stdlib.h>
#include <string.h>
//#include "stdafx.h"
//#include "visualprogrammer3.h"
#include "Datatypes.h"
#include "GuidTypDef.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGuidTypDef::CGuidTypDef()
{
	m_attribdef=0;m_state=GTDS_notset;
}


CGuidTypDef::CGuidTypDef( const CGuidTypDef &p )	// Copy-Konstruktor
{
	m_Guid=p.m_Guid;m_attribdef=0;m_state=p.m_state;

	SetAttribDef(p.m_attribdef);
}

CGuidTypDef::~CGuidTypDef()
{
	if(m_attribdef)free(m_attribdef);
}



void CGuidTypDef::SetGuid( const GUID &p )
{
	m_Guid=p;
}

const GUID &CGuidTypDef::GetGuid( void ) const
{
	return(m_Guid);
}

void CGuidTypDef::SetAttribDef( const char *p )
{
	if(m_attribdef)free(m_attribdef);
	
	if(p)
	{
		m_attribdef=(char *)malloc(strlen(p)+1);
		assert(m_attribdef);
		strcpy(m_attribdef,p);
	}
	else m_attribdef=0;
}

const char *CGuidTypDef::GetAttribDef( void ) const		// mu 0-terminiert sein
{
	return(m_attribdef);
}


CGuidTypDef	CGuidTypDef::operator =( const CGuidTypDef &p )		// Zuweisungsoperator, ist const hier ok?
{
	SetGuid(p.GetGuid());
	SetAttribDef(p.GetAttribDef());
	m_state=p.m_state;

	return(*this);
}




CGuidTypDefState CGuidTypDef::GetState( void ) const
{
	return(m_state);
}

void CGuidTypDef::SetState( CGuidTypDefState state )
{
	m_state=state;
}



bool CGuidTypDef::SameType( const char *typestring )
{
	return(stricmp(typestring,m_attribdef)==0);
}
