#ifndef _HANDLE_H
#define _HANDLE_H

#include <assert.h>


template <class T> class CHandle	// mit diesem Hier kann man Handles auf Objekte realisieren
{
private:
	T *m_Ptr;

	CHandle<T> *GetThis( void ){ return(this); }
public:

	// Konstruktoren
	CHandle( T *ptr ){ if(ptr)ptr->AddRef();m_Ptr=ptr; }
	CHandle(){ m_Ptr=0; }
	
	// Destruktor
	~CHandle(){ if(m_Ptr)m_Ptr->Release(); }
	
	// vergiss nie den Copy Konstruktor zu berladen !!!
	CHandle( CHandle<T> &a )		
	{ 
//		if(m_Ptr)m_Ptr->Release(); is ja noch nix da
		if(a.m_Ptr)a.m_Ptr->AddRef();
		m_Ptr=a.m_Ptr;
	}

	T **operator&( void )		// Referenz auf den Pointer
	{
 		return(&m_Ptr);
	}

	operator T*()				// Konvertierung
	{ 
		return(m_Ptr);
	}
	
	T *operator->()
	{ 
		assert(m_Ptr!=0);
		return(m_Ptr);
	}

	// Zuweisungsoperator
	CHandle<T> operator =( CHandle<T> &a )
	{
		if(this==a.GetThis())return(*this);

		if(m_Ptr)m_Ptr->Release();
		if(a.m_Ptr)a.m_Ptr->AddRef();
		m_Ptr=a.m_Ptr;
		return(*this);
	}

	/*
    operator bool()
	{
		return(GetPtr()!=(T *)0);
	}
	*/

	bool operator==( CHandle<T> &a )
	{
		return(m_Ptr==a.m_Ptr);
	}

	// Zuweisungsoperator
	const T *operator =( T *a )
	{
		if(m_Ptr)m_Ptr->Release();
		if(a)a->AddRef();
		m_Ptr=a;
		return(a);
	}
};



// fr Konvertierungen zwischen Interfaces:

// z.B. 
//
// CHandle<ISceneGraphObject>	n=...;
// CHandle<IWinGUI>				k=GETINTERFACE(n,IWinGui);


static void *__b;
//#define CASTINTERFACE(type,hnd)  ((hnd)->QueryInterface(IID_##type,(LPVOID *)&__b),(__b)?(hnd)->Release():0,(type *)__b)

#define QUERYINTERFACE(type,hnd)  ((hnd!=0)?(((hnd)->QueryInterface(IID_##type,(LPVOID *)&__b),(type *)__b)):0)



#endif	// _HANDLE_H