// SerializeArchiv.h: Schnittstelle fr die Klasse CSerializeArchiv.
//
// Diese Klasse interagiert stark mit SerializeArchivePointer
//
// Die Klasse arbeitet mit fopen,fwrite, ...
// andere Implementierungen sind mglich, die SerializeArchivePointer mu dafr nicht
// gendert werden
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERIALIZEARCHIV_H__32C22DE1_0694_11D4_BD1F_0000B465D2C5__INCLUDED_)
#define AFX_SERIALIZEARCHIV_H__32C22DE1_0694_11D4_BD1F_0000B465D2C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class ISerialize;

#include "SerializeArchivePointer.h"		// CSerializeArchivePointer



class CSerializeArchive : public ISerializePointerCorrection
{
private:
	static CSerializeArchivePointer ar;

	map<GUID,int>						m_mCollection;				// GUID <-> Id Zuordnung
	map<ULONG,IUnknown *>				*m_accessptr;
	const char							*m_actualattribdef;

	FILE								*m_filehandle;

public:
						CSerializeArchive	();
//						CSerializeArchive	( const CSerializeArchive &p );	// Copy-Konstruktor
	virtual				~CSerializeArchive	();

	ISerialize *		Load				( const char *filename );	// liefert Zeiger auf das RootObjekt
	bool				Save				( const char *filename, 
											  ISerialize *what );		// true, wenn kein Fehler

	// Interface ISerializePointerCorrection
virtual IUnknown *		Convert				( ULONG old );
virtual const char *	GetAttribDef		( void );					// fr Recovery load
virtual void			RegisterGUID		( const GUID &g, 
											  ULONG keyid );			// 
virtual ULONG			GetKeyFromGUID		( const GUID &g );			// liefert key-id zurck
virtual bool			IsGUIDRegistered	( const GUID &g );			// liefert true, wenn GUID noch nicht in der map war
virtual void			WriteObjHeader		( const ULONG guid_id, 
											  const IUnknown *oldptr );	// fr saveAPTR
virtual	void			WriteObjDefBlock	( const void *def, 
											  const ULONG size, 
											  const GUID &guid );		// Definition der folgenden ObjektDaten
virtual void			WriteObjDataBlock	( const void *data, 
											  const ULONG size );		// Daten des Objektes
};

#endif // !defined(AFX_SERIALIZEARCHIV_H__32C22DE1_0694_11D4_BD1F_0000B465D2C5__INCLUDED_)
