// SerializeArchivePointer.h: Schnittstelle fr die Klasse CSerializeArchivePointer.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERIALIZEARCHIVEPOINTER_H__32C22DEF_0694_11D4_BD1F_0000B465D2C5__INCLUDED_)
#define AFX_SERIALIZEARCHIVEPOINTER_H__32C22DEF_0694_11D4_BD1F_0000B465D2C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "stdio.h"		// FILE
#include "Datatypes.h"

struct IUnknown;
class ISerialize;

#include <map>
#include <string>
using namespace std;

#include "Handle.h"			// CHandle




class ISerializePointerCorrection
{
public:
	virtual IUnknown *	Convert				( ULONG old )=0;
	
	virtual const char *GetAttribDef		( void )=0;						// fr Recovery load
	
	virtual void		RegisterGUID		( const GUID &g, 
											  ULONG keyid )=0;				// registriert mit key-id
	
	virtual ULONG		GetKeyFromGUID		( const GUID &g )=0;			// liefert key-id zurck
	
	virtual bool		IsGUIDRegistered	( const GUID &g )=0;			// liefert true, wenn GUID noch nicht in der map war
	
	virtual void		WriteObjHeader		( const ULONG guid_id, 
											  const IUnknown *oldmempos )=0;// fr saveAPTR
	
	virtual void		WriteObjDefBlock	( const void *def, 
											  const ULONG size, 
											  const GUID &guid )=0;			// Definition der folgenden ObjektDaten

	virtual void		WriteObjDataBlock	( const void *data, 
											  const ULONG size )=0;			// Daten des Objektes
};








enum CSerializeArchiveMode
{
	CSAM_notset			=0,		// undefiniert
	CSAM_loadADEF		=10,	// Attributdefinition fr Fastread/Recover (einmal pro Objekttyp)
	CSAM_loadADAT_f		=11,	// Laden der Attributdaten fastread
	CSAM_loadADAT_r		=12,	// Laden der Attributdaten recover
	CSAM_saveADEF		=20,	// Speichern der Attributdefinition	(einmal pro SGO)
	CSAM_saveADAT		=21,	// Speichern der Attributdaten		(fr jede Instanz eines SGO)
	CSAM_saveAPTR		=22,	// Speichern der Attributdaten		(fr jede Instanz eines SGO)

//	CSAM_getattribdef	=4  // Attributdefinition	(einmal pro SGO)
};

#define MEM_ATTRIBDEF		16*1024	// 16KB (Speicherblock fr die Attibute-definition einer SGO Klasse)
									// dieser Wert sollte auf "ewig" reichen.
#define MEM_ATTRIBDAT		64*1024 // 64KB Speicher fr die Attribute eines SGO 
									// dieser Speicher knnte knapp evtl. nicht reichen			



class CSerializeArchivePointer  
{
public:
					CSerializeArchivePointer();
	virtual			~CSerializeArchivePointer();

					CSerializeArchivePointer( CSerializeArchivePointer &c )	// Copy Konstruktor
					{
						assert(0);	// nicht erlaubt
					}

	bool			BeforeSerialize		( ISerialize *what );				// vor jedem Serialize() aufrufen
	void			AfterSerialize		( ISerialize *what );				// nach jedem Serialize() aufrufen

	bool			Dbool				( bool &value,	char *name );		// 8  Bit
	bool			Dchar				( char &value,	char *name );		// 8  Bit
	bool			Dshort				( short &value,	char *name );		// 16 Bit
	bool			Dint				( int &alue,	char *name );		// 32 Bit
	bool			Dfloat				( float &value,	char *name );		// 32 Bit
	bool			Ddouble				( double &value, char *name );		// 64 Bit
	bool			Dstring				( string &value, char *name );		// 8*k Bit
	bool			DHandle				( const GUID &IId, IUnknown * &value, char *name );	// 32 Bit

	CSerializeArchiveMode	GetMode		( void );


	void			SetSaveModeADEF		( void );					// darf nur CSerializeArchive machen
	void			FlushBuffer			( void );					// nach jeder Objektdef/Objektdaten		
	void			SetSaveModeADAT		( void );					// darf nur CSerializeArchive machen
	void			SetSaveModeAPTR		( void );					// darf nur CSerializeArchive machen
	void			SetLoadModeADAT_r	( void );	// recover - darf nur CSerializeArchive machen
	void			SetLoadModeADAT_f	( void );	// fastread - darf nur CSerializeArchive machen
	void			SetLoadModeADEF		( void );					// darf nur CSerializeArchive machen

	void *			GetBufferAndSize	( ULONG &size );			// nullterminiert bei ADEFs
	void *			SetBufferAndInit	( void );					// Puffer kann hiermit mit Daten gefllt werden

	void			SetCallback			( ISerializePointerCorrection *callback );
//	void			Open				( class ISerialize *root, ISerializePointerCorrection *callback );
//	void			Close				( void );

	ULONG			GetCounter			( void );

private:

	bool			AppendAttribDef		( char *type, char *name );

	void			RearrangeMemory		( char *intype, char *outtype, void *inmem, void *outmem );

//	bool			FindInAttrString	( char *in_data, ULONG &out_relindex, ULONG &out_attribsize );
	void *			FindInAttrString	( char *in_type, char *in_name );


	CSerializeArchiveMode			m_mode;

	char							m_attribdef[MEM_ATTRIBDEF];
	int								m_attribdefsize;
	
	char							m_attribdat[MEM_ATTRIBDAT*2];	// sollte evtl. dynamisch allociert werden
	int								m_attribdatsize;				// *2, da der Speicher als Quelle und Ziel benutzt wird
	
	ISerialize *					m_aktObject;
	ISerializePointerCorrection	*	m_CallbackPtr;
	ULONG							m_counter;						// fr SetSaveModeADEF ,SetSaveModeAPTR
};








/*
// weil das hier ein template ist, darf es nicht in die cpp datei
template <class T>
bool CSerializeArchivePointer::DHandle( const GUID &IId, CHandle<T> &value, char *name )	// 32 Bit
{

	// Check, ob IId zu CHandle passt
#ifdef DEBUG
	{
			T *p;
			value->QueryInterface(IId,(LPVOID*)&p);
			assert(value.GetPtr()==p);
	}
#endif

	switch(m_mode)
	{ 
		case CSAM_load:

//			fuck
			
			break;
		case CSAM_saveADAT:		
			{			// 0xffffffff
				T *i;
				value->QueryInterface(IUnknown,(LPVOID*)&i);assert(i);

				ULONG *p=(ULONG *)&m_attribdat[m_attribdatsize];

				*p=(ULONG)i;m_attribdatsize+=4;

				i->ReleaseInterface();
			}
			break;
		case CSAM_saveADEF:
			AppendAttribDef("H4",name);			// H=Handle
			break;
		default:	assert(0);return(false);
	}

	return(false);
}
*/


// z.B. AR_HANDLE(ISceneGraphObject,m_hLeft,"left");
#define AR_HANDLE(iname,var,name)													\
	{ IUnknown *ptr; if(var){ var->QueryInterface(IID_IUnknown,(LPVOID*)&ptr);assert(ptr); }	\
		else ptr=0;	ar.DHandle(IID_##iname,ptr,name);								\
	iname *ptr2=0;																	\
	if(ptr){ ptr->QueryInterface(IID_##iname,(void **)&ptr2);assert(ptr2); }		\
	var=ptr2; }																		\


#endif // !defined(AFX_SERIALIZEARCHIVEPOINTER_H__32C22DEF_0694_11D4_BD1F_0000B465D2C5__INCLUDED_)
